// Copyright (c) 2014, the Dart project authors. Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

// THIS FILE IS GENERATED. DO NOT EDIT.
//
// Instead modify 'pkg/analyzer/messages.yaml' and run
// 'dart run pkg/analyzer/tool/messages/generate.dart' to update.

// We allow some snake_case and SCREAMING_SNAKE_CASE identifiers in generated
// code, as they match names declared in the source configuration files.
// ignore_for_file: constant_identifier_names

// While transitioning `HintCodes` to `WarningCodes`, we refer to deprecated
// codes here.
// ignore_for_file: deprecated_member_use_from_same_package

import 'package:_fe_analyzer_shared/src/base/analyzer_public_api.dart';
import 'package:_fe_analyzer_shared/src/base/errors.dart';
import 'package:analyzer/src/dart/error/ffi_code.dart';
import 'package:analyzer/src/dart/error/syntactic_errors.dart';
import 'package:analyzer/src/error/codes.dart';
import 'package:analyzer/src/manifest/manifest_warning_code.dart';
import 'package:analyzer/src/pubspec/pubspec_warning_code.dart';

@AnalyzerPublicApi(message: 'exported by lib/error/error.dart')
const List<ErrorCode> errorCodeValues = [
  AnalysisOptionsErrorCode.INCLUDED_FILE_PARSE_ERROR,
  AnalysisOptionsErrorCode.PARSE_ERROR,
  AnalysisOptionsHintCode.DEPRECATED_LINT,
  AnalysisOptionsHintCode.DEPRECATED_LINT_WITH_REPLACEMENT,
  AnalysisOptionsHintCode.DUPLICATE_RULE,
  AnalysisOptionsWarningCode.ANALYSIS_OPTION_DEPRECATED,
  AnalysisOptionsWarningCode.ANALYSIS_OPTION_DEPRECATED_WITH_REPLACEMENT,
  AnalysisOptionsWarningCode.INCLUDED_FILE_WARNING,
  AnalysisOptionsWarningCode.INCLUDE_FILE_NOT_FOUND,
  AnalysisOptionsWarningCode.INCOMPATIBLE_LINT,
  AnalysisOptionsWarningCode.INVALID_OPTION,
  AnalysisOptionsWarningCode.INVALID_SECTION_FORMAT,
  AnalysisOptionsWarningCode.MULTIPLE_PLUGINS,
  AnalysisOptionsWarningCode.RECURSIVE_INCLUDE_FILE,
  AnalysisOptionsWarningCode.REMOVED_LINT,
  AnalysisOptionsWarningCode.REPLACED_LINT,
  AnalysisOptionsWarningCode.UNDEFINED_LINT,
  AnalysisOptionsWarningCode.UNRECOGNIZED_ERROR_CODE,
  AnalysisOptionsWarningCode.UNSUPPORTED_OPTION_WITHOUT_VALUES,
  AnalysisOptionsWarningCode.UNSUPPORTED_OPTION_WITH_LEGAL_VALUE,
  AnalysisOptionsWarningCode.UNSUPPORTED_OPTION_WITH_LEGAL_VALUES,
  AnalysisOptionsWarningCode.UNSUPPORTED_VALUE,
  CompileTimeErrorCode.ABSTRACT_FIELD_CONSTRUCTOR_INITIALIZER,
  CompileTimeErrorCode.ABSTRACT_FIELD_INITIALIZER,
  CompileTimeErrorCode.ABSTRACT_SUPER_MEMBER_REFERENCE,
  CompileTimeErrorCode.AMBIGUOUS_EXPORT,
  CompileTimeErrorCode.AMBIGUOUS_EXTENSION_MEMBER_ACCESS_THREE_OR_MORE,
  CompileTimeErrorCode.AMBIGUOUS_EXTENSION_MEMBER_ACCESS_TWO,
  CompileTimeErrorCode.AMBIGUOUS_IMPORT,
  CompileTimeErrorCode.AMBIGUOUS_SET_OR_MAP_LITERAL_BOTH,
  CompileTimeErrorCode.AMBIGUOUS_SET_OR_MAP_LITERAL_EITHER,
  CompileTimeErrorCode.ARGUMENT_TYPE_NOT_ASSIGNABLE,
  CompileTimeErrorCode.ASSERT_IN_REDIRECTING_CONSTRUCTOR,
  CompileTimeErrorCode.ASSIGNMENT_TO_CONST,
  CompileTimeErrorCode.ASSIGNMENT_TO_FINAL,
  CompileTimeErrorCode.ASSIGNMENT_TO_FINAL_LOCAL,
  CompileTimeErrorCode.ASSIGNMENT_TO_FINAL_NO_SETTER,
  CompileTimeErrorCode.ASSIGNMENT_TO_FUNCTION,
  CompileTimeErrorCode.ASSIGNMENT_TO_METHOD,
  CompileTimeErrorCode.ASSIGNMENT_TO_TYPE,
  CompileTimeErrorCode.ASYNC_FOR_IN_WRONG_CONTEXT,
  CompileTimeErrorCode.AUGMENTATION_EXTENDS_CLAUSE_ALREADY_PRESENT,
  CompileTimeErrorCode.AUGMENTATION_MODIFIER_EXTRA,
  CompileTimeErrorCode.AUGMENTATION_MODIFIER_MISSING,
  CompileTimeErrorCode.AUGMENTATION_OF_DIFFERENT_DECLARATION_KIND,
  CompileTimeErrorCode.AUGMENTATION_TYPE_PARAMETER_BOUND,
  CompileTimeErrorCode.AUGMENTATION_TYPE_PARAMETER_COUNT,
  CompileTimeErrorCode.AUGMENTATION_TYPE_PARAMETER_NAME,
  CompileTimeErrorCode.AUGMENTATION_WITHOUT_DECLARATION,
  CompileTimeErrorCode.AUGMENTED_EXPRESSION_IS_NOT_SETTER,
  CompileTimeErrorCode.AUGMENTED_EXPRESSION_IS_SETTER,
  CompileTimeErrorCode.AUGMENTED_EXPRESSION_NOT_OPERATOR,
  CompileTimeErrorCode.AWAIT_IN_LATE_LOCAL_VARIABLE_INITIALIZER,
  CompileTimeErrorCode.AWAIT_IN_WRONG_CONTEXT,
  CompileTimeErrorCode.AWAIT_OF_INCOMPATIBLE_TYPE,
  CompileTimeErrorCode.BASE_CLASS_IMPLEMENTED_OUTSIDE_OF_LIBRARY,
  CompileTimeErrorCode.BASE_MIXIN_IMPLEMENTED_OUTSIDE_OF_LIBRARY,
  CompileTimeErrorCode.BODY_MIGHT_COMPLETE_NORMALLY,
  CompileTimeErrorCode.BREAK_LABEL_ON_SWITCH_MEMBER,
  CompileTimeErrorCode.BUILT_IN_IDENTIFIER_AS_EXTENSION_NAME,
  CompileTimeErrorCode.BUILT_IN_IDENTIFIER_AS_EXTENSION_TYPE_NAME,
  CompileTimeErrorCode.BUILT_IN_IDENTIFIER_AS_PREFIX_NAME,
  CompileTimeErrorCode.BUILT_IN_IDENTIFIER_AS_TYPE,
  CompileTimeErrorCode.BUILT_IN_IDENTIFIER_AS_TYPEDEF_NAME,
  CompileTimeErrorCode.BUILT_IN_IDENTIFIER_AS_TYPE_NAME,
  CompileTimeErrorCode.BUILT_IN_IDENTIFIER_AS_TYPE_PARAMETER_NAME,
  CompileTimeErrorCode.CASE_EXPRESSION_TYPE_IMPLEMENTS_EQUALS,
  CompileTimeErrorCode.CASE_EXPRESSION_TYPE_IS_NOT_SWITCH_EXPRESSION_SUBTYPE,
  CompileTimeErrorCode.CAST_TO_NON_TYPE,
  CompileTimeErrorCode.CLASS_INSTANTIATION_ACCESS_TO_INSTANCE_MEMBER,
  CompileTimeErrorCode.CLASS_INSTANTIATION_ACCESS_TO_STATIC_MEMBER,
  CompileTimeErrorCode.CLASS_INSTANTIATION_ACCESS_TO_UNKNOWN_MEMBER,
  CompileTimeErrorCode.CLASS_USED_AS_MIXIN,
  CompileTimeErrorCode.CONCRETE_CLASS_HAS_ENUM_SUPERINTERFACE,
  CompileTimeErrorCode.CONCRETE_CLASS_WITH_ABSTRACT_MEMBER,
  CompileTimeErrorCode.CONFLICTING_CONSTRUCTOR_AND_STATIC_FIELD,
  CompileTimeErrorCode.CONFLICTING_CONSTRUCTOR_AND_STATIC_GETTER,
  CompileTimeErrorCode.CONFLICTING_CONSTRUCTOR_AND_STATIC_METHOD,
  CompileTimeErrorCode.CONFLICTING_CONSTRUCTOR_AND_STATIC_SETTER,
  CompileTimeErrorCode.CONFLICTING_FIELD_AND_METHOD,
  CompileTimeErrorCode.CONFLICTING_GENERIC_INTERFACES,
  CompileTimeErrorCode.CONFLICTING_INHERITED_METHOD_AND_SETTER,
  CompileTimeErrorCode.CONFLICTING_METHOD_AND_FIELD,
  CompileTimeErrorCode.CONFLICTING_STATIC_AND_INSTANCE,
  CompileTimeErrorCode.CONFLICTING_TYPE_VARIABLE_AND_CLASS,
  CompileTimeErrorCode.CONFLICTING_TYPE_VARIABLE_AND_ENUM,
  CompileTimeErrorCode.CONFLICTING_TYPE_VARIABLE_AND_EXTENSION,
  CompileTimeErrorCode.CONFLICTING_TYPE_VARIABLE_AND_EXTENSION_TYPE,
  CompileTimeErrorCode.CONFLICTING_TYPE_VARIABLE_AND_MEMBER_CLASS,
  CompileTimeErrorCode.CONFLICTING_TYPE_VARIABLE_AND_MEMBER_ENUM,
  CompileTimeErrorCode.CONFLICTING_TYPE_VARIABLE_AND_MEMBER_EXTENSION,
  CompileTimeErrorCode.CONFLICTING_TYPE_VARIABLE_AND_MEMBER_EXTENSION_TYPE,
  CompileTimeErrorCode.CONFLICTING_TYPE_VARIABLE_AND_MEMBER_MIXIN,
  CompileTimeErrorCode.CONFLICTING_TYPE_VARIABLE_AND_MIXIN,
  CompileTimeErrorCode.CONSTANT_PATTERN_WITH_NON_CONSTANT_EXPRESSION,
  CompileTimeErrorCode.CONST_CONSTRUCTOR_CONSTANT_FROM_DEFERRED_LIBRARY,
  CompileTimeErrorCode.CONST_CONSTRUCTOR_FIELD_TYPE_MISMATCH,
  CompileTimeErrorCode.CONST_CONSTRUCTOR_PARAM_TYPE_MISMATCH,
  CompileTimeErrorCode.CONST_CONSTRUCTOR_THROWS_EXCEPTION,
  CompileTimeErrorCode.CONST_CONSTRUCTOR_WITH_FIELD_INITIALIZED_BY_NON_CONST,
  CompileTimeErrorCode.CONST_CONSTRUCTOR_WITH_MIXIN_WITH_FIELD,
  CompileTimeErrorCode.CONST_CONSTRUCTOR_WITH_MIXIN_WITH_FIELDS,
  CompileTimeErrorCode.CONST_CONSTRUCTOR_WITH_NON_CONST_SUPER,
  CompileTimeErrorCode.CONST_CONSTRUCTOR_WITH_NON_FINAL_FIELD,
  CompileTimeErrorCode.CONST_DEFERRED_CLASS,
  CompileTimeErrorCode.CONST_EVAL_ASSERTION_FAILURE,
  CompileTimeErrorCode.CONST_EVAL_ASSERTION_FAILURE_WITH_MESSAGE,
  CompileTimeErrorCode.CONST_EVAL_EXTENSION_METHOD,
  CompileTimeErrorCode.CONST_EVAL_EXTENSION_TYPE_METHOD,
  CompileTimeErrorCode.CONST_EVAL_FOR_ELEMENT,
  CompileTimeErrorCode.CONST_EVAL_METHOD_INVOCATION,
  CompileTimeErrorCode.CONST_EVAL_PRIMITIVE_EQUALITY,
  CompileTimeErrorCode.CONST_EVAL_PROPERTY_ACCESS,
  CompileTimeErrorCode.CONST_EVAL_THROWS_EXCEPTION,
  CompileTimeErrorCode.CONST_EVAL_THROWS_IDBZE,
  CompileTimeErrorCode.CONST_EVAL_TYPE_BOOL,
  CompileTimeErrorCode.CONST_EVAL_TYPE_BOOL_INT,
  CompileTimeErrorCode.CONST_EVAL_TYPE_BOOL_NUM_STRING,
  CompileTimeErrorCode.CONST_EVAL_TYPE_INT,
  CompileTimeErrorCode.CONST_EVAL_TYPE_NUM,
  CompileTimeErrorCode.CONST_EVAL_TYPE_NUM_STRING,
  CompileTimeErrorCode.CONST_EVAL_TYPE_STRING,
  CompileTimeErrorCode.CONST_EVAL_TYPE_TYPE,
  CompileTimeErrorCode.CONST_FIELD_INITIALIZER_NOT_ASSIGNABLE,
  CompileTimeErrorCode.CONST_INITIALIZED_WITH_NON_CONSTANT_VALUE,
  CompileTimeErrorCode
      .CONST_INITIALIZED_WITH_NON_CONSTANT_VALUE_FROM_DEFERRED_LIBRARY,
  CompileTimeErrorCode.CONST_INSTANCE_FIELD,
  CompileTimeErrorCode.CONST_MAP_KEY_NOT_PRIMITIVE_EQUALITY,
  CompileTimeErrorCode.CONST_NOT_INITIALIZED,
  CompileTimeErrorCode.CONST_SET_ELEMENT_NOT_PRIMITIVE_EQUALITY,
  CompileTimeErrorCode.CONST_SPREAD_EXPECTED_LIST_OR_SET,
  CompileTimeErrorCode.CONST_SPREAD_EXPECTED_MAP,
  CompileTimeErrorCode.CONST_TYPE_PARAMETER,
  CompileTimeErrorCode.CONST_WITH_NON_CONST,
  CompileTimeErrorCode.CONST_WITH_NON_CONSTANT_ARGUMENT,
  CompileTimeErrorCode.CONST_WITH_NON_TYPE,
  CompileTimeErrorCode.CONST_WITH_TYPE_PARAMETERS,
  CompileTimeErrorCode.CONST_WITH_TYPE_PARAMETERS_CONSTRUCTOR_TEAROFF,
  CompileTimeErrorCode.CONST_WITH_TYPE_PARAMETERS_FUNCTION_TEAROFF,
  CompileTimeErrorCode.CONST_WITH_UNDEFINED_CONSTRUCTOR,
  CompileTimeErrorCode.CONST_WITH_UNDEFINED_CONSTRUCTOR_DEFAULT,
  CompileTimeErrorCode.CONTINUE_LABEL_INVALID,
  CompileTimeErrorCode.COULD_NOT_INFER,
  CompileTimeErrorCode.DEFAULT_VALUE_IN_REDIRECTING_FACTORY_CONSTRUCTOR,
  CompileTimeErrorCode.DEFAULT_VALUE_ON_REQUIRED_PARAMETER,
  CompileTimeErrorCode.DEFERRED_IMPORT_OF_EXTENSION,
  CompileTimeErrorCode.DEFINITELY_UNASSIGNED_LATE_LOCAL_VARIABLE,
  CompileTimeErrorCode.DISALLOWED_TYPE_INSTANTIATION_EXPRESSION,
  CompileTimeErrorCode.DUPLICATE_CONSTRUCTOR_DEFAULT,
  CompileTimeErrorCode.DUPLICATE_CONSTRUCTOR_NAME,
  CompileTimeErrorCode.DUPLICATE_DEFINITION,
  CompileTimeErrorCode.DUPLICATE_FIELD_FORMAL_PARAMETER,
  CompileTimeErrorCode.DUPLICATE_FIELD_NAME,
  CompileTimeErrorCode.DUPLICATE_NAMED_ARGUMENT,
  CompileTimeErrorCode.DUPLICATE_PART,
  CompileTimeErrorCode.DUPLICATE_PATTERN_ASSIGNMENT_VARIABLE,
  CompileTimeErrorCode.DUPLICATE_PATTERN_FIELD,
  CompileTimeErrorCode.DUPLICATE_REST_ELEMENT_IN_PATTERN,
  CompileTimeErrorCode.DUPLICATE_VARIABLE_PATTERN,
  CompileTimeErrorCode.EMPTY_MAP_PATTERN,
  CompileTimeErrorCode.ENUM_CONSTANT_INVOKES_FACTORY_CONSTRUCTOR,
  CompileTimeErrorCode.ENUM_CONSTANT_SAME_NAME_AS_ENCLOSING,
  CompileTimeErrorCode.ENUM_INSTANTIATED_TO_BOUNDS_IS_NOT_WELL_BOUNDED,
  CompileTimeErrorCode.ENUM_MIXIN_WITH_INSTANCE_VARIABLE,
  CompileTimeErrorCode.ENUM_WITHOUT_CONSTANTS,
  CompileTimeErrorCode.ENUM_WITH_ABSTRACT_MEMBER,
  CompileTimeErrorCode.ENUM_WITH_NAME_VALUES,
  CompileTimeErrorCode.EQUAL_ELEMENTS_IN_CONST_SET,
  CompileTimeErrorCode.EQUAL_KEYS_IN_CONST_MAP,
  CompileTimeErrorCode.EQUAL_KEYS_IN_MAP_PATTERN,
  CompileTimeErrorCode.EXPECTED_ONE_LIST_PATTERN_TYPE_ARGUMENTS,
  CompileTimeErrorCode.EXPECTED_ONE_LIST_TYPE_ARGUMENTS,
  CompileTimeErrorCode.EXPECTED_ONE_SET_TYPE_ARGUMENTS,
  CompileTimeErrorCode.EXPECTED_TWO_MAP_PATTERN_TYPE_ARGUMENTS,
  CompileTimeErrorCode.EXPECTED_TWO_MAP_TYPE_ARGUMENTS,
  CompileTimeErrorCode.EXPORT_INTERNAL_LIBRARY,
  CompileTimeErrorCode.EXPORT_OF_NON_LIBRARY,
  CompileTimeErrorCode.EXPRESSION_IN_MAP,
  CompileTimeErrorCode.EXTENDS_DEFERRED_CLASS,
  CompileTimeErrorCode.EXTENDS_DISALLOWED_CLASS,
  CompileTimeErrorCode.EXTENDS_NON_CLASS,
  CompileTimeErrorCode.EXTENDS_TYPE_ALIAS_EXPANDS_TO_TYPE_PARAMETER,
  CompileTimeErrorCode.EXTENSION_AS_EXPRESSION,
  CompileTimeErrorCode.EXTENSION_CONFLICTING_STATIC_AND_INSTANCE,
  CompileTimeErrorCode.EXTENSION_DECLARES_INSTANCE_FIELD,
  CompileTimeErrorCode.EXTENSION_DECLARES_MEMBER_OF_OBJECT,
  CompileTimeErrorCode.EXTENSION_OVERRIDE_ACCESS_TO_STATIC_MEMBER,
  CompileTimeErrorCode.EXTENSION_OVERRIDE_ARGUMENT_NOT_ASSIGNABLE,
  CompileTimeErrorCode.EXTENSION_OVERRIDE_WITHOUT_ACCESS,
  CompileTimeErrorCode.EXTENSION_OVERRIDE_WITH_CASCADE,
  CompileTimeErrorCode.EXTENSION_TYPE_CONSTRUCTOR_WITH_SUPER_FORMAL_PARAMETER,
  CompileTimeErrorCode.EXTENSION_TYPE_CONSTRUCTOR_WITH_SUPER_INVOCATION,
  CompileTimeErrorCode.EXTENSION_TYPE_DECLARES_INSTANCE_FIELD,
  CompileTimeErrorCode.EXTENSION_TYPE_DECLARES_MEMBER_OF_OBJECT,
  CompileTimeErrorCode.EXTENSION_TYPE_IMPLEMENTS_DISALLOWED_TYPE,
  CompileTimeErrorCode.EXTENSION_TYPE_IMPLEMENTS_ITSELF,
  CompileTimeErrorCode.EXTENSION_TYPE_IMPLEMENTS_NOT_SUPERTYPE,
  CompileTimeErrorCode.EXTENSION_TYPE_IMPLEMENTS_REPRESENTATION_NOT_SUPERTYPE,
  CompileTimeErrorCode.EXTENSION_TYPE_INHERITED_MEMBER_CONFLICT,
  CompileTimeErrorCode.EXTENSION_TYPE_REPRESENTATION_DEPENDS_ON_ITSELF,
  CompileTimeErrorCode.EXTENSION_TYPE_REPRESENTATION_TYPE_BOTTOM,
  CompileTimeErrorCode.EXTENSION_TYPE_WITH_ABSTRACT_MEMBER,
  CompileTimeErrorCode.EXTERNAL_FIELD_CONSTRUCTOR_INITIALIZER,
  CompileTimeErrorCode.EXTERNAL_FIELD_INITIALIZER,
  CompileTimeErrorCode.EXTERNAL_VARIABLE_INITIALIZER,
  CompileTimeErrorCode.EXTRA_POSITIONAL_ARGUMENTS,
  CompileTimeErrorCode.EXTRA_POSITIONAL_ARGUMENTS_COULD_BE_NAMED,
  CompileTimeErrorCode.FIELD_INITIALIZED_BY_MULTIPLE_INITIALIZERS,
  CompileTimeErrorCode.FIELD_INITIALIZED_IN_INITIALIZER_AND_DECLARATION,
  CompileTimeErrorCode.FIELD_INITIALIZED_IN_PARAMETER_AND_INITIALIZER,
  CompileTimeErrorCode.FIELD_INITIALIZER_FACTORY_CONSTRUCTOR,
  CompileTimeErrorCode.FIELD_INITIALIZER_NOT_ASSIGNABLE,
  CompileTimeErrorCode.FIELD_INITIALIZER_OUTSIDE_CONSTRUCTOR,
  CompileTimeErrorCode.FIELD_INITIALIZER_REDIRECTING_CONSTRUCTOR,
  CompileTimeErrorCode.FIELD_INITIALIZING_FORMAL_NOT_ASSIGNABLE,
  CompileTimeErrorCode.FINAL_CLASS_EXTENDED_OUTSIDE_OF_LIBRARY,
  CompileTimeErrorCode.FINAL_CLASS_IMPLEMENTED_OUTSIDE_OF_LIBRARY,
  CompileTimeErrorCode.FINAL_CLASS_USED_AS_MIXIN_CONSTRAINT_OUTSIDE_OF_LIBRARY,
  CompileTimeErrorCode.FINAL_INITIALIZED_IN_DECLARATION_AND_CONSTRUCTOR,
  CompileTimeErrorCode.FINAL_NOT_INITIALIZED,
  CompileTimeErrorCode.FINAL_NOT_INITIALIZED_CONSTRUCTOR_1,
  CompileTimeErrorCode.FINAL_NOT_INITIALIZED_CONSTRUCTOR_2,
  CompileTimeErrorCode.FINAL_NOT_INITIALIZED_CONSTRUCTOR_3_PLUS,
  CompileTimeErrorCode.FOR_IN_OF_INVALID_ELEMENT_TYPE,
  CompileTimeErrorCode.FOR_IN_OF_INVALID_TYPE,
  CompileTimeErrorCode.FOR_IN_WITH_CONST_VARIABLE,
  CompileTimeErrorCode.GENERIC_FUNCTION_TYPE_CANNOT_BE_BOUND,
  CompileTimeErrorCode.GENERIC_FUNCTION_TYPE_CANNOT_BE_TYPE_ARGUMENT,
  CompileTimeErrorCode.GENERIC_METHOD_TYPE_INSTANTIATION_ON_DYNAMIC,
  CompileTimeErrorCode.GETTER_NOT_ASSIGNABLE_SETTER_TYPES,
  CompileTimeErrorCode.GETTER_NOT_SUBTYPE_SETTER_TYPES,
  CompileTimeErrorCode.IF_ELEMENT_CONDITION_FROM_DEFERRED_LIBRARY,
  CompileTimeErrorCode.ILLEGAL_ASYNC_GENERATOR_RETURN_TYPE,
  CompileTimeErrorCode.ILLEGAL_ASYNC_RETURN_TYPE,
  CompileTimeErrorCode.ILLEGAL_CONCRETE_ENUM_MEMBER_DECLARATION,
  CompileTimeErrorCode.ILLEGAL_CONCRETE_ENUM_MEMBER_INHERITANCE,
  CompileTimeErrorCode.ILLEGAL_ENUM_VALUES_DECLARATION,
  CompileTimeErrorCode.ILLEGAL_ENUM_VALUES_INHERITANCE,
  CompileTimeErrorCode.ILLEGAL_LANGUAGE_VERSION_OVERRIDE,
  CompileTimeErrorCode.ILLEGAL_SYNC_GENERATOR_RETURN_TYPE,
  CompileTimeErrorCode.IMPLEMENTS_DEFERRED_CLASS,
  CompileTimeErrorCode.IMPLEMENTS_DISALLOWED_CLASS,
  CompileTimeErrorCode.IMPLEMENTS_NON_CLASS,
  CompileTimeErrorCode.IMPLEMENTS_REPEATED,
  CompileTimeErrorCode.IMPLEMENTS_SUPER_CLASS,
  CompileTimeErrorCode.IMPLEMENTS_TYPE_ALIAS_EXPANDS_TO_TYPE_PARAMETER,
  CompileTimeErrorCode.IMPLICIT_SUPER_INITIALIZER_MISSING_ARGUMENTS,
  CompileTimeErrorCode.IMPLICIT_THIS_REFERENCE_IN_INITIALIZER,
  CompileTimeErrorCode.IMPORT_INTERNAL_LIBRARY,
  CompileTimeErrorCode.IMPORT_OF_NON_LIBRARY,
  CompileTimeErrorCode.INCONSISTENT_CASE_EXPRESSION_TYPES,
  CompileTimeErrorCode.INCONSISTENT_INHERITANCE,
  CompileTimeErrorCode.INCONSISTENT_INHERITANCE_GETTER_AND_METHOD,
  CompileTimeErrorCode.INCONSISTENT_LANGUAGE_VERSION_OVERRIDE,
  CompileTimeErrorCode.INCONSISTENT_PATTERN_VARIABLE_LOGICAL_OR,
  CompileTimeErrorCode.INITIALIZER_FOR_NON_EXISTENT_FIELD,
  CompileTimeErrorCode.INITIALIZER_FOR_STATIC_FIELD,
  CompileTimeErrorCode.INITIALIZING_FORMAL_FOR_NON_EXISTENT_FIELD,
  CompileTimeErrorCode.INSTANCE_ACCESS_TO_STATIC_MEMBER,
  CompileTimeErrorCode.INSTANCE_ACCESS_TO_STATIC_MEMBER_OF_UNNAMED_EXTENSION,
  CompileTimeErrorCode.INSTANCE_MEMBER_ACCESS_FROM_FACTORY,
  CompileTimeErrorCode.INSTANCE_MEMBER_ACCESS_FROM_STATIC,
  CompileTimeErrorCode.INSTANTIATE_ABSTRACT_CLASS,
  CompileTimeErrorCode.INSTANTIATE_ENUM,
  CompileTimeErrorCode.INSTANTIATE_TYPE_ALIAS_EXPANDS_TO_TYPE_PARAMETER,
  CompileTimeErrorCode.INTEGER_LITERAL_IMPRECISE_AS_DOUBLE,
  CompileTimeErrorCode.INTEGER_LITERAL_OUT_OF_RANGE,
  CompileTimeErrorCode.INTERFACE_CLASS_EXTENDED_OUTSIDE_OF_LIBRARY,
  CompileTimeErrorCode.INVALID_ANNOTATION,
  CompileTimeErrorCode.INVALID_ANNOTATION_CONSTANT_VALUE_FROM_DEFERRED_LIBRARY,
  CompileTimeErrorCode.INVALID_ANNOTATION_FROM_DEFERRED_LIBRARY,
  CompileTimeErrorCode.INVALID_ASSIGNMENT,
  CompileTimeErrorCode.INVALID_CAST_FUNCTION,
  CompileTimeErrorCode.INVALID_CAST_FUNCTION_EXPR,
  CompileTimeErrorCode.INVALID_CAST_LITERAL,
  CompileTimeErrorCode.INVALID_CAST_LITERAL_LIST,
  CompileTimeErrorCode.INVALID_CAST_LITERAL_MAP,
  CompileTimeErrorCode.INVALID_CAST_LITERAL_SET,
  CompileTimeErrorCode.INVALID_CAST_METHOD,
  CompileTimeErrorCode.INVALID_CAST_NEW_EXPR,
  CompileTimeErrorCode.INVALID_CONSTANT,
  CompileTimeErrorCode.INVALID_EXTENSION_ARGUMENT_COUNT,
  CompileTimeErrorCode.INVALID_FACTORY_NAME_NOT_A_CLASS,
  CompileTimeErrorCode.INVALID_FIELD_NAME_FROM_OBJECT,
  CompileTimeErrorCode.INVALID_FIELD_NAME_POSITIONAL,
  CompileTimeErrorCode.INVALID_FIELD_NAME_PRIVATE,
  CompileTimeErrorCode.INVALID_IMPLEMENTATION_OVERRIDE,
  CompileTimeErrorCode.INVALID_IMPLEMENTATION_OVERRIDE_SETTER,
  CompileTimeErrorCode.INVALID_INLINE_FUNCTION_TYPE,
  CompileTimeErrorCode.INVALID_MODIFIER_ON_CONSTRUCTOR,
  CompileTimeErrorCode.INVALID_MODIFIER_ON_SETTER,
  CompileTimeErrorCode.INVALID_OVERRIDE,
  CompileTimeErrorCode.INVALID_OVERRIDE_SETTER,
  CompileTimeErrorCode.INVALID_REFERENCE_TO_GENERATIVE_ENUM_CONSTRUCTOR,
  CompileTimeErrorCode.INVALID_REFERENCE_TO_THIS,
  CompileTimeErrorCode.INVALID_SUPER_FORMAL_PARAMETER_LOCATION,
  CompileTimeErrorCode.INVALID_TYPE_ARGUMENT_IN_CONST_LIST,
  CompileTimeErrorCode.INVALID_TYPE_ARGUMENT_IN_CONST_MAP,
  CompileTimeErrorCode.INVALID_TYPE_ARGUMENT_IN_CONST_SET,
  CompileTimeErrorCode.INVALID_URI,
  CompileTimeErrorCode.INVALID_USE_OF_COVARIANT,
  CompileTimeErrorCode.INVALID_USE_OF_NULL_VALUE,
  CompileTimeErrorCode.INVOCATION_OF_EXTENSION_WITHOUT_CALL,
  CompileTimeErrorCode.INVOCATION_OF_NON_FUNCTION,
  CompileTimeErrorCode.INVOCATION_OF_NON_FUNCTION_EXPRESSION,
  CompileTimeErrorCode.LABEL_IN_OUTER_SCOPE,
  CompileTimeErrorCode.LABEL_UNDEFINED,
  CompileTimeErrorCode.LATE_FINAL_FIELD_WITH_CONST_CONSTRUCTOR,
  CompileTimeErrorCode.LATE_FINAL_LOCAL_ALREADY_ASSIGNED,
  CompileTimeErrorCode.LIST_ELEMENT_TYPE_NOT_ASSIGNABLE,
  CompileTimeErrorCode.LIST_ELEMENT_TYPE_NOT_ASSIGNABLE_NULLABILITY,
  CompileTimeErrorCode.MAIN_FIRST_POSITIONAL_PARAMETER_TYPE,
  CompileTimeErrorCode.MAIN_HAS_REQUIRED_NAMED_PARAMETERS,
  CompileTimeErrorCode.MAIN_HAS_TOO_MANY_REQUIRED_POSITIONAL_PARAMETERS,
  CompileTimeErrorCode.MAIN_IS_NOT_FUNCTION,
  CompileTimeErrorCode.MAP_ENTRY_NOT_IN_MAP,
  CompileTimeErrorCode.MAP_KEY_TYPE_NOT_ASSIGNABLE,
  CompileTimeErrorCode.MAP_KEY_TYPE_NOT_ASSIGNABLE_NULLABILITY,
  CompileTimeErrorCode.MAP_VALUE_TYPE_NOT_ASSIGNABLE,
  CompileTimeErrorCode.MAP_VALUE_TYPE_NOT_ASSIGNABLE_NULLABILITY,
  CompileTimeErrorCode.MISSING_CONST_IN_LIST_LITERAL,
  CompileTimeErrorCode.MISSING_CONST_IN_MAP_LITERAL,
  CompileTimeErrorCode.MISSING_CONST_IN_SET_LITERAL,
  CompileTimeErrorCode.MISSING_DART_LIBRARY,
  CompileTimeErrorCode.MISSING_DEFAULT_VALUE_FOR_PARAMETER,
  CompileTimeErrorCode.MISSING_DEFAULT_VALUE_FOR_PARAMETER_POSITIONAL,
  CompileTimeErrorCode.MISSING_DEFAULT_VALUE_FOR_PARAMETER_WITH_ANNOTATION,
  CompileTimeErrorCode.MISSING_NAMED_PATTERN_FIELD_NAME,
  CompileTimeErrorCode.MISSING_REQUIRED_ARGUMENT,
  CompileTimeErrorCode.MISSING_VARIABLE_PATTERN,
  CompileTimeErrorCode.MIXINS_SUPER_CLASS,
  CompileTimeErrorCode.MIXIN_APPLICATION_CONCRETE_SUPER_INVOKED_MEMBER_TYPE,
  CompileTimeErrorCode.MIXIN_APPLICATION_NOT_IMPLEMENTED_INTERFACE,
  CompileTimeErrorCode.MIXIN_APPLICATION_NO_CONCRETE_SUPER_INVOKED_MEMBER,
  CompileTimeErrorCode.MIXIN_APPLICATION_NO_CONCRETE_SUPER_INVOKED_SETTER,
  CompileTimeErrorCode.MIXIN_CLASS_DECLARATION_EXTENDS_NOT_OBJECT,
  CompileTimeErrorCode.MIXIN_CLASS_DECLARES_CONSTRUCTOR,
  CompileTimeErrorCode.MIXIN_DEFERRED_CLASS,
  CompileTimeErrorCode.MIXIN_INHERITS_FROM_NOT_OBJECT,
  CompileTimeErrorCode.MIXIN_INSTANTIATE,
  CompileTimeErrorCode.MIXIN_OF_DISALLOWED_CLASS,
  CompileTimeErrorCode.MIXIN_OF_NON_CLASS,
  CompileTimeErrorCode.MIXIN_OF_TYPE_ALIAS_EXPANDS_TO_TYPE_PARAMETER,
  CompileTimeErrorCode.MIXIN_ON_TYPE_ALIAS_EXPANDS_TO_TYPE_PARAMETER,
  CompileTimeErrorCode.MIXIN_SUBTYPE_OF_BASE_IS_NOT_BASE,
  CompileTimeErrorCode.MIXIN_SUBTYPE_OF_FINAL_IS_NOT_BASE,
  CompileTimeErrorCode.MIXIN_SUPER_CLASS_CONSTRAINT_DEFERRED_CLASS,
  CompileTimeErrorCode.MIXIN_SUPER_CLASS_CONSTRAINT_DISALLOWED_CLASS,
  CompileTimeErrorCode.MIXIN_SUPER_CLASS_CONSTRAINT_NON_INTERFACE,
  CompileTimeErrorCode.MIXIN_WITH_NON_CLASS_SUPERCLASS,
  CompileTimeErrorCode.MULTIPLE_REDIRECTING_CONSTRUCTOR_INVOCATIONS,
  CompileTimeErrorCode.MULTIPLE_SUPER_INITIALIZERS,
  CompileTimeErrorCode.NEW_WITH_NON_TYPE,
  CompileTimeErrorCode.NEW_WITH_UNDEFINED_CONSTRUCTOR,
  CompileTimeErrorCode.NEW_WITH_UNDEFINED_CONSTRUCTOR_DEFAULT,
  CompileTimeErrorCode.NON_ABSTRACT_CLASS_INHERITS_ABSTRACT_MEMBER_FIVE_PLUS,
  CompileTimeErrorCode.NON_ABSTRACT_CLASS_INHERITS_ABSTRACT_MEMBER_FOUR,
  CompileTimeErrorCode.NON_ABSTRACT_CLASS_INHERITS_ABSTRACT_MEMBER_ONE,
  CompileTimeErrorCode.NON_ABSTRACT_CLASS_INHERITS_ABSTRACT_MEMBER_THREE,
  CompileTimeErrorCode.NON_ABSTRACT_CLASS_INHERITS_ABSTRACT_MEMBER_TWO,
  CompileTimeErrorCode.NON_BOOL_CONDITION,
  CompileTimeErrorCode.NON_BOOL_EXPRESSION,
  CompileTimeErrorCode.NON_BOOL_NEGATION_EXPRESSION,
  CompileTimeErrorCode.NON_BOOL_OPERAND,
  CompileTimeErrorCode.NON_CONSTANT_ANNOTATION_CONSTRUCTOR,
  CompileTimeErrorCode.NON_CONSTANT_CASE_EXPRESSION,
  CompileTimeErrorCode.NON_CONSTANT_CASE_EXPRESSION_FROM_DEFERRED_LIBRARY,
  CompileTimeErrorCode.NON_CONSTANT_DEFAULT_VALUE,
  CompileTimeErrorCode.NON_CONSTANT_DEFAULT_VALUE_FROM_DEFERRED_LIBRARY,
  CompileTimeErrorCode.NON_CONSTANT_LIST_ELEMENT,
  CompileTimeErrorCode.NON_CONSTANT_LIST_ELEMENT_FROM_DEFERRED_LIBRARY,
  CompileTimeErrorCode.NON_CONSTANT_MAP_ELEMENT,
  CompileTimeErrorCode.NON_CONSTANT_MAP_KEY,
  CompileTimeErrorCode.NON_CONSTANT_MAP_KEY_FROM_DEFERRED_LIBRARY,
  CompileTimeErrorCode.NON_CONSTANT_MAP_PATTERN_KEY,
  CompileTimeErrorCode.NON_CONSTANT_MAP_VALUE,
  CompileTimeErrorCode.NON_CONSTANT_MAP_VALUE_FROM_DEFERRED_LIBRARY,
  CompileTimeErrorCode.NON_CONSTANT_RECORD_FIELD,
  CompileTimeErrorCode.NON_CONSTANT_RECORD_FIELD_FROM_DEFERRED_LIBRARY,
  CompileTimeErrorCode.NON_CONSTANT_RELATIONAL_PATTERN_EXPRESSION,
  CompileTimeErrorCode.NON_CONSTANT_SET_ELEMENT,
  CompileTimeErrorCode.NON_CONST_GENERATIVE_ENUM_CONSTRUCTOR,
  CompileTimeErrorCode.NON_CONST_MAP_AS_EXPRESSION_STATEMENT,
  CompileTimeErrorCode
      .NON_COVARIANT_TYPE_PARAMETER_POSITION_IN_REPRESENTATION_TYPE,
  CompileTimeErrorCode.NON_EXHAUSTIVE_SWITCH_EXPRESSION,
  CompileTimeErrorCode.NON_EXHAUSTIVE_SWITCH_STATEMENT,
  CompileTimeErrorCode.NON_FINAL_FIELD_IN_ENUM,
  CompileTimeErrorCode.NON_GENERATIVE_CONSTRUCTOR,
  CompileTimeErrorCode.NON_GENERATIVE_IMPLICIT_CONSTRUCTOR,
  CompileTimeErrorCode.NON_SYNC_FACTORY,
  CompileTimeErrorCode.NON_TYPE_AS_TYPE_ARGUMENT,
  CompileTimeErrorCode.NON_TYPE_IN_CATCH_CLAUSE,
  CompileTimeErrorCode.NON_VOID_RETURN_FOR_OPERATOR,
  CompileTimeErrorCode.NON_VOID_RETURN_FOR_SETTER,
  CompileTimeErrorCode.NOT_ASSIGNED_POTENTIALLY_NON_NULLABLE_LOCAL_VARIABLE,
  CompileTimeErrorCode.NOT_A_TYPE,
  CompileTimeErrorCode.NOT_BINARY_OPERATOR,
  CompileTimeErrorCode.NOT_ENOUGH_POSITIONAL_ARGUMENTS_NAME_PLURAL,
  CompileTimeErrorCode.NOT_ENOUGH_POSITIONAL_ARGUMENTS_NAME_SINGULAR,
  CompileTimeErrorCode.NOT_ENOUGH_POSITIONAL_ARGUMENTS_PLURAL,
  CompileTimeErrorCode.NOT_ENOUGH_POSITIONAL_ARGUMENTS_SINGULAR,
  CompileTimeErrorCode.NOT_INITIALIZED_NON_NULLABLE_INSTANCE_FIELD,
  CompileTimeErrorCode.NOT_INITIALIZED_NON_NULLABLE_INSTANCE_FIELD_CONSTRUCTOR,
  CompileTimeErrorCode.NOT_INITIALIZED_NON_NULLABLE_VARIABLE,
  CompileTimeErrorCode.NOT_INSTANTIATED_BOUND,
  CompileTimeErrorCode.NOT_ITERABLE_SPREAD,
  CompileTimeErrorCode.NOT_MAP_SPREAD,
  CompileTimeErrorCode.NOT_NULL_AWARE_NULL_SPREAD,
  CompileTimeErrorCode.NO_ANNOTATION_CONSTRUCTOR_ARGUMENTS,
  CompileTimeErrorCode.NO_COMBINED_SUPER_SIGNATURE,
  CompileTimeErrorCode.NO_DEFAULT_SUPER_CONSTRUCTOR_EXPLICIT,
  CompileTimeErrorCode.NO_DEFAULT_SUPER_CONSTRUCTOR_IMPLICIT,
  CompileTimeErrorCode.NO_GENERATIVE_CONSTRUCTORS_IN_SUPERCLASS,
  CompileTimeErrorCode.NULLABLE_TYPE_IN_EXTENDS_CLAUSE,
  CompileTimeErrorCode.NULLABLE_TYPE_IN_IMPLEMENTS_CLAUSE,
  CompileTimeErrorCode.NULLABLE_TYPE_IN_ON_CLAUSE,
  CompileTimeErrorCode.NULLABLE_TYPE_IN_WITH_CLAUSE,
  CompileTimeErrorCode.OBJECT_CANNOT_EXTEND_ANOTHER_CLASS,
  CompileTimeErrorCode.OBSOLETE_COLON_FOR_DEFAULT_VALUE,
  CompileTimeErrorCode.ON_REPEATED,
  CompileTimeErrorCode.OPTIONAL_PARAMETER_IN_OPERATOR,
  CompileTimeErrorCode.PART_OF_DIFFERENT_LIBRARY,
  CompileTimeErrorCode.PART_OF_NON_PART,
  CompileTimeErrorCode.PART_OF_UNNAMED_LIBRARY,
  CompileTimeErrorCode.PATTERN_ASSIGNMENT_NOT_LOCAL_VARIABLE,
  CompileTimeErrorCode.PATTERN_CONSTANT_FROM_DEFERRED_LIBRARY,
  CompileTimeErrorCode.PATTERN_TYPE_MISMATCH_IN_IRREFUTABLE_CONTEXT,
  CompileTimeErrorCode.PATTERN_VARIABLE_ASSIGNMENT_INSIDE_GUARD,
  CompileTimeErrorCode
      .PATTERN_VARIABLE_SHARED_CASE_SCOPE_DIFFERENT_FINALITY_OR_TYPE,
  CompileTimeErrorCode.PATTERN_VARIABLE_SHARED_CASE_SCOPE_HAS_LABEL,
  CompileTimeErrorCode.PATTERN_VARIABLE_SHARED_CASE_SCOPE_NOT_ALL_CASES,
  CompileTimeErrorCode.POSITIONAL_FIELD_IN_OBJECT_PATTERN,
  CompileTimeErrorCode
      .POSITIONAL_SUPER_FORMAL_PARAMETER_WITH_POSITIONAL_ARGUMENT,
  CompileTimeErrorCode.PREFIX_COLLIDES_WITH_TOP_LEVEL_MEMBER,
  CompileTimeErrorCode.PREFIX_IDENTIFIER_NOT_FOLLOWED_BY_DOT,
  CompileTimeErrorCode.PREFIX_SHADOWED_BY_LOCAL_DECLARATION,
  CompileTimeErrorCode.PRIVATE_COLLISION_IN_MIXIN_APPLICATION,
  CompileTimeErrorCode.PRIVATE_OPTIONAL_PARAMETER,
  CompileTimeErrorCode.PRIVATE_SETTER,
  CompileTimeErrorCode.READ_POTENTIALLY_UNASSIGNED_FINAL,
  CompileTimeErrorCode.RECORD_LITERAL_ONE_POSITIONAL_NO_TRAILING_COMMA,
  CompileTimeErrorCode.RECURSIVE_COMPILE_TIME_CONSTANT,
  CompileTimeErrorCode.RECURSIVE_CONSTANT_CONSTRUCTOR,
  CompileTimeErrorCode.RECURSIVE_CONSTRUCTOR_REDIRECT,
  CompileTimeErrorCode.RECURSIVE_FACTORY_REDIRECT,
  CompileTimeErrorCode.RECURSIVE_INTERFACE_INHERITANCE,
  CompileTimeErrorCode.RECURSIVE_INTERFACE_INHERITANCE_EXTENDS,
  CompileTimeErrorCode.RECURSIVE_INTERFACE_INHERITANCE_IMPLEMENTS,
  CompileTimeErrorCode.RECURSIVE_INTERFACE_INHERITANCE_ON,
  CompileTimeErrorCode.RECURSIVE_INTERFACE_INHERITANCE_WITH,
  CompileTimeErrorCode.REDIRECT_GENERATIVE_TO_MISSING_CONSTRUCTOR,
  CompileTimeErrorCode.REDIRECT_GENERATIVE_TO_NON_GENERATIVE_CONSTRUCTOR,
  CompileTimeErrorCode.REDIRECT_TO_ABSTRACT_CLASS_CONSTRUCTOR,
  CompileTimeErrorCode.REDIRECT_TO_INVALID_FUNCTION_TYPE,
  CompileTimeErrorCode.REDIRECT_TO_INVALID_RETURN_TYPE,
  CompileTimeErrorCode.REDIRECT_TO_MISSING_CONSTRUCTOR,
  CompileTimeErrorCode.REDIRECT_TO_NON_CLASS,
  CompileTimeErrorCode.REDIRECT_TO_NON_CONST_CONSTRUCTOR,
  CompileTimeErrorCode.REDIRECT_TO_TYPE_ALIAS_EXPANDS_TO_TYPE_PARAMETER,
  CompileTimeErrorCode.REFERENCED_BEFORE_DECLARATION,
  CompileTimeErrorCode.REFUTABLE_PATTERN_IN_IRREFUTABLE_CONTEXT,
  CompileTimeErrorCode.RELATIONAL_PATTERN_OPERAND_TYPE_NOT_ASSIGNABLE,
  CompileTimeErrorCode
      .RELATIONAL_PATTERN_OPERATOR_RETURN_TYPE_NOT_ASSIGNABLE_TO_BOOL,
  CompileTimeErrorCode.REST_ELEMENT_IN_MAP_PATTERN,
  CompileTimeErrorCode.RETHROW_OUTSIDE_CATCH,
  CompileTimeErrorCode.RETURN_IN_GENERATIVE_CONSTRUCTOR,
  CompileTimeErrorCode.RETURN_IN_GENERATOR,
  CompileTimeErrorCode.RETURN_OF_INVALID_TYPE_FROM_CLOSURE,
  CompileTimeErrorCode.RETURN_OF_INVALID_TYPE_FROM_CONSTRUCTOR,
  CompileTimeErrorCode.RETURN_OF_INVALID_TYPE_FROM_FUNCTION,
  CompileTimeErrorCode.RETURN_OF_INVALID_TYPE_FROM_METHOD,
  CompileTimeErrorCode.RETURN_WITHOUT_VALUE,
  CompileTimeErrorCode.SEALED_CLASS_SUBTYPE_OUTSIDE_OF_LIBRARY,
  CompileTimeErrorCode.SET_ELEMENT_FROM_DEFERRED_LIBRARY,
  CompileTimeErrorCode.SET_ELEMENT_TYPE_NOT_ASSIGNABLE,
  CompileTimeErrorCode.SET_ELEMENT_TYPE_NOT_ASSIGNABLE_NULLABILITY,
  CompileTimeErrorCode.SHARED_DEFERRED_PREFIX,
  CompileTimeErrorCode.SPREAD_EXPRESSION_FROM_DEFERRED_LIBRARY,
  CompileTimeErrorCode.STATIC_ACCESS_TO_INSTANCE_MEMBER,
  CompileTimeErrorCode.SUBTYPE_OF_BASE_IS_NOT_BASE_FINAL_OR_SEALED,
  CompileTimeErrorCode.SUBTYPE_OF_FINAL_IS_NOT_BASE_FINAL_OR_SEALED,
  CompileTimeErrorCode.SUPER_FORMAL_PARAMETER_TYPE_IS_NOT_SUBTYPE_OF_ASSOCIATED,
  CompileTimeErrorCode.SUPER_FORMAL_PARAMETER_WITHOUT_ASSOCIATED_NAMED,
  CompileTimeErrorCode.SUPER_FORMAL_PARAMETER_WITHOUT_ASSOCIATED_POSITIONAL,
  CompileTimeErrorCode.SUPER_INITIALIZER_IN_OBJECT,
  CompileTimeErrorCode.SUPER_INVOCATION_NOT_LAST,
  CompileTimeErrorCode.SUPER_IN_ENUM_CONSTRUCTOR,
  CompileTimeErrorCode.SUPER_IN_EXTENSION,
  CompileTimeErrorCode.SUPER_IN_EXTENSION_TYPE,
  CompileTimeErrorCode.SUPER_IN_INVALID_CONTEXT,
  CompileTimeErrorCode.SUPER_IN_REDIRECTING_CONSTRUCTOR,
  CompileTimeErrorCode.SWITCH_CASE_COMPLETES_NORMALLY,
  CompileTimeErrorCode.TEAROFF_OF_GENERATIVE_CONSTRUCTOR_OF_ABSTRACT_CLASS,
  CompileTimeErrorCode.THROW_OF_INVALID_TYPE,
  CompileTimeErrorCode.TOP_LEVEL_CYCLE,
  CompileTimeErrorCode.TYPE_ALIAS_CANNOT_REFERENCE_ITSELF,
  CompileTimeErrorCode.TYPE_ANNOTATION_DEFERRED_CLASS,
  CompileTimeErrorCode.TYPE_ARGUMENT_NOT_MATCHING_BOUNDS,
  CompileTimeErrorCode.TYPE_PARAMETER_REFERENCED_BY_STATIC,
  CompileTimeErrorCode.TYPE_PARAMETER_SUPERTYPE_OF_ITS_BOUND,
  CompileTimeErrorCode.TYPE_TEST_WITH_NON_TYPE,
  CompileTimeErrorCode.TYPE_TEST_WITH_UNDEFINED_NAME,
  CompileTimeErrorCode.UNCHECKED_INVOCATION_OF_NULLABLE_VALUE,
  CompileTimeErrorCode.UNCHECKED_METHOD_INVOCATION_OF_NULLABLE_VALUE,
  CompileTimeErrorCode.UNCHECKED_OPERATOR_INVOCATION_OF_NULLABLE_VALUE,
  CompileTimeErrorCode.UNCHECKED_PROPERTY_ACCESS_OF_NULLABLE_VALUE,
  CompileTimeErrorCode.UNCHECKED_USE_OF_NULLABLE_VALUE_AS_CONDITION,
  CompileTimeErrorCode.UNCHECKED_USE_OF_NULLABLE_VALUE_AS_ITERATOR,
  CompileTimeErrorCode.UNCHECKED_USE_OF_NULLABLE_VALUE_IN_SPREAD,
  CompileTimeErrorCode.UNCHECKED_USE_OF_NULLABLE_VALUE_IN_YIELD_EACH,
  CompileTimeErrorCode.UNDEFINED_ANNOTATION,
  CompileTimeErrorCode.UNDEFINED_CLASS,
  CompileTimeErrorCode.UNDEFINED_CLASS_BOOLEAN,
  CompileTimeErrorCode.UNDEFINED_CONSTRUCTOR_IN_INITIALIZER,
  CompileTimeErrorCode.UNDEFINED_CONSTRUCTOR_IN_INITIALIZER_DEFAULT,
  CompileTimeErrorCode.UNDEFINED_ENUM_CONSTANT,
  CompileTimeErrorCode.UNDEFINED_ENUM_CONSTRUCTOR_NAMED,
  CompileTimeErrorCode.UNDEFINED_ENUM_CONSTRUCTOR_UNNAMED,
  CompileTimeErrorCode.UNDEFINED_EXTENSION_GETTER,
  CompileTimeErrorCode.UNDEFINED_EXTENSION_METHOD,
  CompileTimeErrorCode.UNDEFINED_EXTENSION_OPERATOR,
  CompileTimeErrorCode.UNDEFINED_EXTENSION_SETTER,
  CompileTimeErrorCode.UNDEFINED_FUNCTION,
  CompileTimeErrorCode.UNDEFINED_GETTER,
  CompileTimeErrorCode.UNDEFINED_GETTER_ON_FUNCTION_TYPE,
  CompileTimeErrorCode.UNDEFINED_IDENTIFIER,
  CompileTimeErrorCode.UNDEFINED_IDENTIFIER_AWAIT,
  CompileTimeErrorCode.UNDEFINED_METHOD,
  CompileTimeErrorCode.UNDEFINED_METHOD_ON_FUNCTION_TYPE,
  CompileTimeErrorCode.UNDEFINED_NAMED_PARAMETER,
  CompileTimeErrorCode.UNDEFINED_OPERATOR,
  CompileTimeErrorCode.UNDEFINED_PREFIXED_NAME,
  CompileTimeErrorCode.UNDEFINED_SETTER,
  CompileTimeErrorCode.UNDEFINED_SETTER_ON_FUNCTION_TYPE,
  CompileTimeErrorCode.UNDEFINED_SUPER_GETTER,
  CompileTimeErrorCode.UNDEFINED_SUPER_METHOD,
  CompileTimeErrorCode.UNDEFINED_SUPER_OPERATOR,
  CompileTimeErrorCode.UNDEFINED_SUPER_SETTER,
  CompileTimeErrorCode.UNQUALIFIED_REFERENCE_TO_NON_LOCAL_STATIC_MEMBER,
  CompileTimeErrorCode.UNQUALIFIED_REFERENCE_TO_STATIC_MEMBER_OF_EXTENDED_TYPE,
  CompileTimeErrorCode.URI_DOES_NOT_EXIST,
  CompileTimeErrorCode.URI_HAS_NOT_BEEN_GENERATED,
  CompileTimeErrorCode.URI_WITH_INTERPOLATION,
  CompileTimeErrorCode.USE_OF_NATIVE_EXTENSION,
  CompileTimeErrorCode.USE_OF_VOID_RESULT,
  CompileTimeErrorCode.VALUES_DECLARATION_IN_ENUM,
  CompileTimeErrorCode.VARIABLE_TYPE_MISMATCH,
  CompileTimeErrorCode.WRONG_EXPLICIT_TYPE_PARAMETER_VARIANCE_IN_SUPERINTERFACE,
  CompileTimeErrorCode.WRONG_NUMBER_OF_PARAMETERS_FOR_OPERATOR,
  CompileTimeErrorCode.WRONG_NUMBER_OF_PARAMETERS_FOR_OPERATOR_MINUS,
  CompileTimeErrorCode.WRONG_NUMBER_OF_PARAMETERS_FOR_SETTER,
  CompileTimeErrorCode.WRONG_NUMBER_OF_TYPE_ARGUMENTS,
  CompileTimeErrorCode.WRONG_NUMBER_OF_TYPE_ARGUMENTS_ANONYMOUS_FUNCTION,
  CompileTimeErrorCode.WRONG_NUMBER_OF_TYPE_ARGUMENTS_CONSTRUCTOR,
  CompileTimeErrorCode.WRONG_NUMBER_OF_TYPE_ARGUMENTS_ENUM,
  CompileTimeErrorCode.WRONG_NUMBER_OF_TYPE_ARGUMENTS_EXTENSION,
  CompileTimeErrorCode.WRONG_NUMBER_OF_TYPE_ARGUMENTS_FUNCTION,
  CompileTimeErrorCode.WRONG_NUMBER_OF_TYPE_ARGUMENTS_METHOD,
  CompileTimeErrorCode.WRONG_TYPE_PARAMETER_VARIANCE_IN_SUPERINTERFACE,
  CompileTimeErrorCode.WRONG_TYPE_PARAMETER_VARIANCE_POSITION,
  CompileTimeErrorCode.YIELD_EACH_IN_NON_GENERATOR,
  CompileTimeErrorCode.YIELD_EACH_OF_INVALID_TYPE,
  CompileTimeErrorCode.YIELD_IN_NON_GENERATOR,
  CompileTimeErrorCode.YIELD_OF_INVALID_TYPE,
  FfiCode.ABI_SPECIFIC_INTEGER_INVALID,
  FfiCode.ABI_SPECIFIC_INTEGER_MAPPING_EXTRA,
  FfiCode.ABI_SPECIFIC_INTEGER_MAPPING_MISSING,
  FfiCode.ABI_SPECIFIC_INTEGER_MAPPING_UNSUPPORTED,
  FfiCode.ADDRESS_POSITION,
  FfiCode.ADDRESS_RECEIVER,
  FfiCode.ANNOTATION_ON_POINTER_FIELD,
  FfiCode.ARGUMENT_MUST_BE_A_CONSTANT,
  FfiCode.ARGUMENT_MUST_BE_NATIVE,
  FfiCode.COMPOUND_IMPLEMENTS_FINALIZABLE,
  FfiCode.CREATION_OF_STRUCT_OR_UNION,
  FfiCode.EMPTY_STRUCT,
  FfiCode.EXTRA_ANNOTATION_ON_STRUCT_FIELD,
  FfiCode.EXTRA_SIZE_ANNOTATION_CARRAY,
  FfiCode.FFI_NATIVE_INVALID_DUPLICATE_DEFAULT_ASSET,
  FfiCode.FFI_NATIVE_INVALID_MULTIPLE_ANNOTATIONS,
  FfiCode.FFI_NATIVE_MUST_BE_EXTERNAL,
  FfiCode
      .FFI_NATIVE_ONLY_CLASSES_EXTENDING_NATIVEFIELDWRAPPERCLASS1_CAN_BE_POINTER,
  FfiCode.FFI_NATIVE_UNEXPECTED_NUMBER_OF_PARAMETERS,
  FfiCode.FFI_NATIVE_UNEXPECTED_NUMBER_OF_PARAMETERS_WITH_RECEIVER,
  FfiCode.FIELD_MUST_BE_EXTERNAL_IN_STRUCT,
  FfiCode.GENERIC_STRUCT_SUBCLASS,
  FfiCode.INVALID_EXCEPTION_VALUE,
  FfiCode.INVALID_FIELD_TYPE_IN_STRUCT,
  FfiCode.LEAF_CALL_MUST_NOT_RETURN_HANDLE,
  FfiCode.LEAF_CALL_MUST_NOT_TAKE_HANDLE,
  FfiCode.MISMATCHED_ANNOTATION_ON_STRUCT_FIELD,
  FfiCode.MISSING_ANNOTATION_ON_STRUCT_FIELD,
  FfiCode.MISSING_EXCEPTION_VALUE,
  FfiCode.MISSING_FIELD_TYPE_IN_STRUCT,
  FfiCode.MISSING_SIZE_ANNOTATION_CARRAY,
  FfiCode.MUST_BE_A_NATIVE_FUNCTION_TYPE,
  FfiCode.MUST_BE_A_SUBTYPE,
  FfiCode.MUST_RETURN_VOID,
  FfiCode.NATIVE_FIELD_INVALID_TYPE,
  FfiCode.NATIVE_FIELD_MISSING_TYPE,
  FfiCode.NATIVE_FIELD_NOT_STATIC,
  FfiCode.NATIVE_FUNCTION_MISSING_TYPE,
  FfiCode.NEGATIVE_VARIABLE_DIMENSION,
  FfiCode.NON_CONSTANT_TYPE_ARGUMENT,
  FfiCode.NON_NATIVE_FUNCTION_TYPE_ARGUMENT_TO_POINTER,
  FfiCode.NON_POSITIVE_ARRAY_DIMENSION,
  FfiCode.NON_SIZED_TYPE_ARGUMENT,
  FfiCode.PACKED_ANNOTATION,
  FfiCode.PACKED_ANNOTATION_ALIGNMENT,
  FfiCode.SIZE_ANNOTATION_DIMENSIONS,
  FfiCode.SUBTYPE_OF_STRUCT_CLASS_IN_EXTENDS,
  FfiCode.SUBTYPE_OF_STRUCT_CLASS_IN_IMPLEMENTS,
  FfiCode.SUBTYPE_OF_STRUCT_CLASS_IN_WITH,
  FfiCode.VARIABLE_LENGTH_ARRAY_NOT_LAST,
  HintCode.DEPRECATED_COLON_FOR_DEFAULT_VALUE,
  HintCode.DEPRECATED_MEMBER_USE,
  HintCode.DEPRECATED_MEMBER_USE_FROM_SAME_PACKAGE,
  HintCode.DEPRECATED_MEMBER_USE_FROM_SAME_PACKAGE_WITH_MESSAGE,
  HintCode.DEPRECATED_MEMBER_USE_WITH_MESSAGE,
  HintCode.IMPORT_DEFERRED_LIBRARY_WITH_LOAD_FUNCTION,
  HintCode.UNNECESSARY_IMPORT,
  ManifestWarningCode.CAMERA_PERMISSIONS_INCOMPATIBLE,
  ManifestWarningCode.NON_RESIZABLE_ACTIVITY,
  ManifestWarningCode.NO_TOUCHSCREEN_FEATURE,
  ManifestWarningCode.PERMISSION_IMPLIES_UNSUPPORTED_HARDWARE,
  ManifestWarningCode.SETTING_ORIENTATION_ON_ACTIVITY,
  ManifestWarningCode.UNSUPPORTED_CHROME_OS_FEATURE,
  ManifestWarningCode.UNSUPPORTED_CHROME_OS_HARDWARE,
  ParserErrorCode.ABSTRACT_CLASS_MEMBER,
  ParserErrorCode.ABSTRACT_EXTERNAL_FIELD,
  ParserErrorCode.ABSTRACT_FINAL_BASE_CLASS,
  ParserErrorCode.ABSTRACT_FINAL_INTERFACE_CLASS,
  ParserErrorCode.ABSTRACT_LATE_FIELD,
  ParserErrorCode.ABSTRACT_SEALED_CLASS,
  ParserErrorCode.ABSTRACT_STATIC_FIELD,
  ParserErrorCode.ABSTRACT_STATIC_METHOD,
  ParserErrorCode.ANNOTATION_ON_TYPE_ARGUMENT,
  ParserErrorCode.ANNOTATION_SPACE_BEFORE_PARENTHESIS,
  ParserErrorCode.ANNOTATION_WITH_TYPE_ARGUMENTS,
  ParserErrorCode.ANNOTATION_WITH_TYPE_ARGUMENTS_UNINSTANTIATED,
  ParserErrorCode.ASYNC_KEYWORD_USED_AS_IDENTIFIER,
  ParserErrorCode.BASE_ENUM,
  ParserErrorCode.BINARY_OPERATOR_WRITTEN_OUT,
  ParserErrorCode.BREAK_OUTSIDE_OF_LOOP,
  ParserErrorCode.CATCH_SYNTAX,
  ParserErrorCode.CATCH_SYNTAX_EXTRA_PARAMETERS,
  ParserErrorCode.CLASS_IN_CLASS,
  ParserErrorCode.COLON_IN_PLACE_OF_IN,
  ParserErrorCode.CONFLICTING_MODIFIERS,
  ParserErrorCode.CONSTRUCTOR_WITH_RETURN_TYPE,
  ParserErrorCode.CONSTRUCTOR_WITH_TYPE_ARGUMENTS,
  ParserErrorCode.CONST_AND_FINAL,
  ParserErrorCode.CONST_CLASS,
  ParserErrorCode.CONST_CONSTRUCTOR_WITH_BODY,
  ParserErrorCode.CONST_FACTORY,
  ParserErrorCode.CONST_METHOD,
  ParserErrorCode.CONTINUE_OUTSIDE_OF_LOOP,
  ParserErrorCode.CONTINUE_WITHOUT_LABEL_IN_CASE,
  ParserErrorCode.COVARIANT_AND_STATIC,
  ParserErrorCode.COVARIANT_CONSTRUCTOR,
  ParserErrorCode.COVARIANT_MEMBER,
  ParserErrorCode.DECLARATION_NAMED_AUGMENTED_INSIDE_AUGMENTATION,
  ParserErrorCode.DEFAULT_IN_SWITCH_EXPRESSION,
  ParserErrorCode.DEFAULT_VALUE_IN_FUNCTION_TYPE,
  ParserErrorCode.DEFERRED_AFTER_PREFIX,
  ParserErrorCode.DIRECTIVE_AFTER_DECLARATION,
  ParserErrorCode.DUPLICATED_MODIFIER,
  ParserErrorCode.DUPLICATE_DEFERRED,
  ParserErrorCode.DUPLICATE_LABEL_IN_SWITCH_STATEMENT,
  ParserErrorCode.DUPLICATE_PREFIX,
  ParserErrorCode.EMPTY_ENUM_BODY,
  ParserErrorCode.EMPTY_RECORD_LITERAL_WITH_COMMA,
  ParserErrorCode.EMPTY_RECORD_TYPE_NAMED_FIELDS_LIST,
  ParserErrorCode.EMPTY_RECORD_TYPE_WITH_COMMA,
  ParserErrorCode.ENUM_IN_CLASS,
  ParserErrorCode.EQUALITY_CANNOT_BE_EQUALITY_OPERAND,
  ParserErrorCode.EXPECTED_CASE_OR_DEFAULT,
  ParserErrorCode.EXPECTED_CATCH_CLAUSE_BODY,
  ParserErrorCode.EXPECTED_CLASS_BODY,
  ParserErrorCode.EXPECTED_CLASS_MEMBER,
  ParserErrorCode.EXPECTED_ELSE_OR_COMMA,
  ParserErrorCode.EXPECTED_EXECUTABLE,
  ParserErrorCode.EXPECTED_EXTENSION_BODY,
  ParserErrorCode.EXPECTED_EXTENSION_TYPE_BODY,
  ParserErrorCode.EXPECTED_FINALLY_CLAUSE_BODY,
  ParserErrorCode.EXPECTED_IDENTIFIER_BUT_GOT_KEYWORD,
  ParserErrorCode.EXPECTED_INSTEAD,
  ParserErrorCode.EXPECTED_LIST_OR_MAP_LITERAL,
  ParserErrorCode.EXPECTED_MIXIN_BODY,
  ParserErrorCode.EXPECTED_NAMED_TYPE_EXTENDS,
  ParserErrorCode.EXPECTED_NAMED_TYPE_IMPLEMENTS,
  ParserErrorCode.EXPECTED_NAMED_TYPE_ON,
  ParserErrorCode.EXPECTED_NAMED_TYPE_WITH,
  ParserErrorCode.EXPECTED_REPRESENTATION_FIELD,
  ParserErrorCode.EXPECTED_REPRESENTATION_TYPE,
  ParserErrorCode.EXPECTED_STRING_LITERAL,
  ParserErrorCode.EXPECTED_SWITCH_EXPRESSION_BODY,
  ParserErrorCode.EXPECTED_SWITCH_STATEMENT_BODY,
  ParserErrorCode.EXPECTED_TOKEN,
  ParserErrorCode.EXPECTED_TRY_STATEMENT_BODY,
  ParserErrorCode.EXPECTED_TYPE_NAME,
  ParserErrorCode.EXPERIMENT_NOT_ENABLED,
  ParserErrorCode.EXPERIMENT_NOT_ENABLED_OFF_BY_DEFAULT,
  ParserErrorCode.EXPORT_DIRECTIVE_AFTER_PART_DIRECTIVE,
  ParserErrorCode.EXTENSION_AUGMENTATION_HAS_ON_CLAUSE,
  ParserErrorCode.EXTENSION_DECLARES_ABSTRACT_MEMBER,
  ParserErrorCode.EXTENSION_DECLARES_CONSTRUCTOR,
  ParserErrorCode.EXTENSION_TYPE_EXTENDS,
  ParserErrorCode.EXTENSION_TYPE_WITH,
  ParserErrorCode.EXTERNAL_CLASS,
  ParserErrorCode.EXTERNAL_CONSTRUCTOR_WITH_BODY,
  ParserErrorCode.EXTERNAL_CONSTRUCTOR_WITH_FIELD_INITIALIZERS,
  ParserErrorCode.EXTERNAL_CONSTRUCTOR_WITH_INITIALIZER,
  ParserErrorCode.EXTERNAL_ENUM,
  ParserErrorCode.EXTERNAL_FACTORY_REDIRECTION,
  ParserErrorCode.EXTERNAL_FACTORY_WITH_BODY,
  ParserErrorCode.EXTERNAL_FIELD,
  ParserErrorCode.EXTERNAL_GETTER_WITH_BODY,
  ParserErrorCode.EXTERNAL_LATE_FIELD,
  ParserErrorCode.EXTERNAL_METHOD_WITH_BODY,
  ParserErrorCode.EXTERNAL_OPERATOR_WITH_BODY,
  ParserErrorCode.EXTERNAL_SETTER_WITH_BODY,
  ParserErrorCode.EXTERNAL_TYPEDEF,
  ParserErrorCode.EXTRANEOUS_MODIFIER,
  ParserErrorCode.EXTRANEOUS_MODIFIER_IN_EXTENSION_TYPE,
  ParserErrorCode.EXTRANEOUS_MODIFIER_IN_PRIMARY_CONSTRUCTOR,
  ParserErrorCode.FACTORY_TOP_LEVEL_DECLARATION,
  ParserErrorCode.FACTORY_WITHOUT_BODY,
  ParserErrorCode.FACTORY_WITH_INITIALIZERS,
  ParserErrorCode.FIELD_INITIALIZED_OUTSIDE_DECLARING_CLASS,
  ParserErrorCode.FIELD_INITIALIZER_OUTSIDE_CONSTRUCTOR,
  ParserErrorCode.FINAL_AND_COVARIANT,
  ParserErrorCode.FINAL_AND_COVARIANT_LATE_WITH_INITIALIZER,
  ParserErrorCode.FINAL_AND_VAR,
  ParserErrorCode.FINAL_CONSTRUCTOR,
  ParserErrorCode.FINAL_ENUM,
  ParserErrorCode.FINAL_METHOD,
  ParserErrorCode.FINAL_MIXIN,
  ParserErrorCode.FINAL_MIXIN_CLASS,
  ParserErrorCode.FUNCTION_TYPED_PARAMETER_VAR,
  ParserErrorCode.GETTER_CONSTRUCTOR,
  ParserErrorCode.GETTER_IN_FUNCTION,
  ParserErrorCode.GETTER_WITH_PARAMETERS,
  ParserErrorCode.ILLEGAL_ASSIGNMENT_TO_NON_ASSIGNABLE,
  ParserErrorCode.ILLEGAL_PATTERN_ASSIGNMENT_VARIABLE_NAME,
  ParserErrorCode.ILLEGAL_PATTERN_IDENTIFIER_NAME,
  ParserErrorCode.ILLEGAL_PATTERN_VARIABLE_NAME,
  ParserErrorCode.IMPLEMENTS_BEFORE_EXTENDS,
  ParserErrorCode.IMPLEMENTS_BEFORE_ON,
  ParserErrorCode.IMPLEMENTS_BEFORE_WITH,
  ParserErrorCode.IMPORT_DIRECTIVE_AFTER_PART_DIRECTIVE,
  ParserErrorCode.INITIALIZED_VARIABLE_IN_FOR_EACH,
  ParserErrorCode.INTERFACE_ENUM,
  ParserErrorCode.INTERFACE_MIXIN,
  ParserErrorCode.INTERFACE_MIXIN_CLASS,
  ParserErrorCode.INVALID_AWAIT_IN_FOR,
  ParserErrorCode.INVALID_CODE_POINT,
  ParserErrorCode.INVALID_COMMENT_REFERENCE,
  ParserErrorCode.INVALID_CONSTANT_CONST_PREFIX,
  ParserErrorCode.INVALID_CONSTANT_PATTERN_BINARY,
  ParserErrorCode.INVALID_CONSTANT_PATTERN_DUPLICATE_CONST,
  ParserErrorCode.INVALID_CONSTANT_PATTERN_EMPTY_RECORD_LITERAL,
  ParserErrorCode.INVALID_CONSTANT_PATTERN_GENERIC,
  ParserErrorCode.INVALID_CONSTANT_PATTERN_NEGATION,
  ParserErrorCode.INVALID_CONSTANT_PATTERN_UNARY,
  ParserErrorCode.INVALID_CONSTRUCTOR_NAME,
  ParserErrorCode.INVALID_GENERIC_FUNCTION_TYPE,
  ParserErrorCode.INVALID_HEX_ESCAPE,
  ParserErrorCode.INVALID_INITIALIZER,
  ParserErrorCode.INVALID_INSIDE_UNARY_PATTERN,
  ParserErrorCode.INVALID_LITERAL_IN_CONFIGURATION,
  ParserErrorCode.INVALID_OPERATOR,
  ParserErrorCode.INVALID_OPERATOR_FOR_SUPER,
  ParserErrorCode.INVALID_OPERATOR_QUESTIONMARK_PERIOD_FOR_SUPER,
  ParserErrorCode.INVALID_STAR_AFTER_ASYNC,
  ParserErrorCode.INVALID_SUPER_IN_INITIALIZER,
  ParserErrorCode.INVALID_SYNC,
  ParserErrorCode.INVALID_THIS_IN_INITIALIZER,
  ParserErrorCode.INVALID_UNICODE_ESCAPE_STARTED,
  ParserErrorCode.INVALID_UNICODE_ESCAPE_U_BRACKET,
  ParserErrorCode.INVALID_UNICODE_ESCAPE_U_NO_BRACKET,
  ParserErrorCode.INVALID_UNICODE_ESCAPE_U_STARTED,
  ParserErrorCode.INVALID_USE_OF_COVARIANT_IN_EXTENSION,
  ParserErrorCode.INVALID_USE_OF_IDENTIFIER_AUGMENTED,
  ParserErrorCode.LATE_PATTERN_VARIABLE_DECLARATION,
  ParserErrorCode.LIBRARY_DIRECTIVE_NOT_FIRST,
  ParserErrorCode.LITERAL_WITH_CLASS,
  ParserErrorCode.LITERAL_WITH_CLASS_AND_NEW,
  ParserErrorCode.LITERAL_WITH_NEW,
  ParserErrorCode.LOCAL_FUNCTION_DECLARATION_MODIFIER,
  ParserErrorCode.MEMBER_WITH_CLASS_NAME,
  ParserErrorCode.MISSING_ASSIGNABLE_SELECTOR,
  ParserErrorCode.MISSING_ASSIGNMENT_IN_INITIALIZER,
  ParserErrorCode.MISSING_CATCH_OR_FINALLY,
  ParserErrorCode.MISSING_CLOSING_PARENTHESIS,
  ParserErrorCode.MISSING_CONST_FINAL_VAR_OR_TYPE,
  ParserErrorCode.MISSING_ENUM_BODY,
  ParserErrorCode.MISSING_EXPRESSION_IN_INITIALIZER,
  ParserErrorCode.MISSING_EXPRESSION_IN_THROW,
  ParserErrorCode.MISSING_FUNCTION_BODY,
  ParserErrorCode.MISSING_FUNCTION_KEYWORD,
  ParserErrorCode.MISSING_FUNCTION_PARAMETERS,
  ParserErrorCode.MISSING_GET,
  ParserErrorCode.MISSING_IDENTIFIER,
  ParserErrorCode.MISSING_INITIALIZER,
  ParserErrorCode.MISSING_KEYWORD_OPERATOR,
  ParserErrorCode.MISSING_METHOD_PARAMETERS,
  ParserErrorCode.MISSING_NAME_FOR_NAMED_PARAMETER,
  ParserErrorCode.MISSING_NAME_IN_LIBRARY_DIRECTIVE,
  ParserErrorCode.MISSING_NAME_IN_PART_OF_DIRECTIVE,
  ParserErrorCode.MISSING_PREFIX_IN_DEFERRED_IMPORT,
  ParserErrorCode.MISSING_PRIMARY_CONSTRUCTOR,
  ParserErrorCode.MISSING_PRIMARY_CONSTRUCTOR_PARAMETERS,
  ParserErrorCode.MISSING_STAR_AFTER_SYNC,
  ParserErrorCode.MISSING_STATEMENT,
  ParserErrorCode.MISSING_TERMINATOR_FOR_PARAMETER_GROUP,
  ParserErrorCode.MISSING_TYPEDEF_PARAMETERS,
  ParserErrorCode.MISSING_VARIABLE_IN_FOR_EACH,
  ParserErrorCode.MIXED_PARAMETER_GROUPS,
  ParserErrorCode.MIXIN_DECLARES_CONSTRUCTOR,
  ParserErrorCode.MIXIN_WITH_CLAUSE,
  ParserErrorCode.MODIFIER_OUT_OF_ORDER,
  ParserErrorCode.MULTIPLE_CLAUSES,
  ParserErrorCode.MULTIPLE_EXTENDS_CLAUSES,
  ParserErrorCode.MULTIPLE_IMPLEMENTS_CLAUSES,
  ParserErrorCode.MULTIPLE_LIBRARY_DIRECTIVES,
  ParserErrorCode.MULTIPLE_NAMED_PARAMETER_GROUPS,
  ParserErrorCode.MULTIPLE_ON_CLAUSES,
  ParserErrorCode.MULTIPLE_PART_OF_DIRECTIVES,
  ParserErrorCode.MULTIPLE_POSITIONAL_PARAMETER_GROUPS,
  ParserErrorCode.MULTIPLE_REPRESENTATION_FIELDS,
  ParserErrorCode.MULTIPLE_VARIABLES_IN_FOR_EACH,
  ParserErrorCode.MULTIPLE_VARIANCE_MODIFIERS,
  ParserErrorCode.MULTIPLE_WITH_CLAUSES,
  ParserErrorCode.NAMED_FUNCTION_EXPRESSION,
  ParserErrorCode.NAMED_FUNCTION_TYPE,
  ParserErrorCode.NAMED_PARAMETER_OUTSIDE_GROUP,
  ParserErrorCode.NATIVE_CLAUSE_IN_NON_SDK_CODE,
  ParserErrorCode.NATIVE_CLAUSE_SHOULD_BE_ANNOTATION,
  ParserErrorCode.NATIVE_FUNCTION_BODY_IN_NON_SDK_CODE,
  ParserErrorCode.NON_CONSTRUCTOR_FACTORY,
  ParserErrorCode.NON_IDENTIFIER_LIBRARY_NAME,
  ParserErrorCode.NON_PART_OF_DIRECTIVE_IN_PART,
  ParserErrorCode.NON_STRING_LITERAL_AS_URI,
  ParserErrorCode.NON_USER_DEFINABLE_OPERATOR,
  ParserErrorCode.NORMAL_BEFORE_OPTIONAL_PARAMETERS,
  ParserErrorCode.NULL_AWARE_CASCADE_OUT_OF_ORDER,
  ParserErrorCode.OUT_OF_ORDER_CLAUSES,
  ParserErrorCode.PART_OF_NAME,
  ParserErrorCode.PATTERN_ASSIGNMENT_DECLARES_VARIABLE,
  ParserErrorCode.PATTERN_VARIABLE_DECLARATION_OUTSIDE_FUNCTION_OR_METHOD,
  ParserErrorCode.POSITIONAL_AFTER_NAMED_ARGUMENT,
  ParserErrorCode.POSITIONAL_PARAMETER_OUTSIDE_GROUP,
  ParserErrorCode.PREFIX_AFTER_COMBINATOR,
  ParserErrorCode.RECORD_LITERAL_ONE_POSITIONAL_NO_TRAILING_COMMA,
  ParserErrorCode.RECORD_TYPE_ONE_POSITIONAL_NO_TRAILING_COMMA,
  ParserErrorCode.REDIRECTING_CONSTRUCTOR_WITH_BODY,
  ParserErrorCode.REDIRECTION_IN_NON_FACTORY_CONSTRUCTOR,
  ParserErrorCode.REPRESENTATION_FIELD_MODIFIER,
  ParserErrorCode.REPRESENTATION_FIELD_TRAILING_COMMA,
  ParserErrorCode.SEALED_ENUM,
  ParserErrorCode.SEALED_MIXIN,
  ParserErrorCode.SEALED_MIXIN_CLASS,
  ParserErrorCode.SETTER_CONSTRUCTOR,
  ParserErrorCode.SETTER_IN_FUNCTION,
  ParserErrorCode.STACK_OVERFLOW,
  ParserErrorCode.STATIC_CONSTRUCTOR,
  ParserErrorCode.STATIC_GETTER_WITHOUT_BODY,
  ParserErrorCode.STATIC_OPERATOR,
  ParserErrorCode.STATIC_SETTER_WITHOUT_BODY,
  ParserErrorCode.SWITCH_HAS_CASE_AFTER_DEFAULT_CASE,
  ParserErrorCode.SWITCH_HAS_MULTIPLE_DEFAULT_CASES,
  ParserErrorCode.TOP_LEVEL_OPERATOR,
  ParserErrorCode.TYPEDEF_IN_CLASS,
  ParserErrorCode.TYPE_ARGUMENTS_ON_TYPE_VARIABLE,
  ParserErrorCode.TYPE_BEFORE_FACTORY,
  ParserErrorCode.TYPE_PARAMETER_ON_CONSTRUCTOR,
  ParserErrorCode.TYPE_PARAMETER_ON_OPERATOR,
  ParserErrorCode.UNEXPECTED_TERMINATOR_FOR_PARAMETER_GROUP,
  ParserErrorCode.UNEXPECTED_TOKEN,
  ParserErrorCode.UNEXPECTED_TOKENS,
  ParserErrorCode.VARIABLE_PATTERN_KEYWORD_IN_DECLARATION_CONTEXT,
  ParserErrorCode.VAR_AND_TYPE,
  ParserErrorCode.VAR_AS_TYPE_NAME,
  ParserErrorCode.VAR_CLASS,
  ParserErrorCode.VAR_ENUM,
  ParserErrorCode.VAR_RETURN_TYPE,
  ParserErrorCode.VAR_TYPEDEF,
  ParserErrorCode.VOID_WITH_TYPE_ARGUMENTS,
  ParserErrorCode.WITH_BEFORE_EXTENDS,
  ParserErrorCode.WRONG_SEPARATOR_FOR_POSITIONAL_PARAMETER,
  ParserErrorCode.WRONG_TERMINATOR_FOR_PARAMETER_GROUP,
  PubspecWarningCode.ASSET_DIRECTORY_DOES_NOT_EXIST,
  PubspecWarningCode.ASSET_DOES_NOT_EXIST,
  PubspecWarningCode.ASSET_FIELD_NOT_LIST,
  PubspecWarningCode.ASSET_MISSING_PATH,
  PubspecWarningCode.ASSET_NOT_STRING,
  PubspecWarningCode.ASSET_NOT_STRING_OR_MAP,
  PubspecWarningCode.ASSET_PATH_NOT_STRING,
  PubspecWarningCode.DEPENDENCIES_FIELD_NOT_MAP,
  PubspecWarningCode.DEPRECATED_FIELD,
  PubspecWarningCode.FLUTTER_FIELD_NOT_MAP,
  PubspecWarningCode.INVALID_DEPENDENCY,
  PubspecWarningCode.INVALID_PLATFORMS_FIELD,
  PubspecWarningCode.MISSING_DEPENDENCY,
  PubspecWarningCode.MISSING_NAME,
  PubspecWarningCode.NAME_NOT_STRING,
  PubspecWarningCode.PATH_DOES_NOT_EXIST,
  PubspecWarningCode.PATH_NOT_POSIX,
  PubspecWarningCode.PATH_PUBSPEC_DOES_NOT_EXIST,
  PubspecWarningCode.PLATFORM_VALUE_DISALLOWED,
  PubspecWarningCode.UNKNOWN_PLATFORM,
  PubspecWarningCode.UNNECESSARY_DEV_DEPENDENCY,
  PubspecWarningCode.WORKSPACE_FIELD_NOT_LIST,
  PubspecWarningCode.WORKSPACE_VALUE_NOT_STRING,
  PubspecWarningCode.WORKSPACE_VALUE_NOT_SUBDIRECTORY,
  ScannerErrorCode.EXPECTED_TOKEN,
  ScannerErrorCode.ILLEGAL_CHARACTER,
  ScannerErrorCode.MISSING_DIGIT,
  ScannerErrorCode.MISSING_HEX_DIGIT,
  ScannerErrorCode.MISSING_IDENTIFIER,
  ScannerErrorCode.MISSING_QUOTE,
  ScannerErrorCode.UNABLE_GET_CONTENT,
  ScannerErrorCode.UNEXPECTED_DOLLAR_IN_STRING,
  ScannerErrorCode.UNSUPPORTED_OPERATOR,
  ScannerErrorCode.UNTERMINATED_MULTI_LINE_COMMENT,
  ScannerErrorCode.UNTERMINATED_STRING_LITERAL,
  StaticWarningCode.DEAD_NULL_AWARE_EXPRESSION,
  StaticWarningCode.INVALID_NULL_AWARE_ELEMENT,
  StaticWarningCode.INVALID_NULL_AWARE_MAP_ENTRY_KEY,
  StaticWarningCode.INVALID_NULL_AWARE_MAP_ENTRY_VALUE,
  StaticWarningCode.INVALID_NULL_AWARE_OPERATOR,
  StaticWarningCode.INVALID_NULL_AWARE_OPERATOR_AFTER_SHORT_CIRCUIT,
  StaticWarningCode.MISSING_ENUM_CONSTANT_IN_SWITCH,
  StaticWarningCode.UNNECESSARY_NON_NULL_ASSERTION,
  StaticWarningCode.UNNECESSARY_NULL_ASSERT_PATTERN,
  StaticWarningCode.UNNECESSARY_NULL_CHECK_PATTERN,
  TodoCode.FIXME,
  TodoCode.HACK,
  TodoCode.TODO,
  TodoCode.UNDONE,
  WarningCode.ARGUMENT_TYPE_NOT_ASSIGNABLE_TO_ERROR_HANDLER,
  WarningCode.ASSIGNMENT_OF_DO_NOT_STORE,
  WarningCode.BODY_MIGHT_COMPLETE_NORMALLY_CATCH_ERROR,
  WarningCode.BODY_MIGHT_COMPLETE_NORMALLY_NULLABLE,
  WarningCode.CAST_FROM_NULLABLE_ALWAYS_FAILS,
  WarningCode.CAST_FROM_NULL_ALWAYS_FAILS,
  WarningCode.CONSTANT_PATTERN_NEVER_MATCHES_VALUE_TYPE,
  WarningCode.DEAD_CODE,
  WarningCode.DEAD_CODE_CATCH_FOLLOWING_CATCH,
  WarningCode.DEAD_CODE_LATE_WILDCARD_VARIABLE_INITIALIZER,
  WarningCode.DEAD_CODE_ON_CATCH_SUBTYPE,
  WarningCode.DEPRECATED_EXPORT_USE,
  WarningCode.DEPRECATED_EXTENDS_FUNCTION,
  WarningCode.DEPRECATED_IMPLEMENTS_FUNCTION,
  WarningCode.DEPRECATED_MIXIN_FUNCTION,
  WarningCode.DEPRECATED_NEW_IN_COMMENT_REFERENCE,
  WarningCode.DOC_DIRECTIVE_ARGUMENT_WRONG_FORMAT,
  WarningCode.DOC_DIRECTIVE_HAS_EXTRA_ARGUMENTS,
  WarningCode.DOC_DIRECTIVE_HAS_UNEXPECTED_NAMED_ARGUMENT,
  WarningCode.DOC_DIRECTIVE_MISSING_CLOSING_BRACE,
  WarningCode.DOC_DIRECTIVE_MISSING_CLOSING_TAG,
  WarningCode.DOC_DIRECTIVE_MISSING_ONE_ARGUMENT,
  WarningCode.DOC_DIRECTIVE_MISSING_OPENING_TAG,
  WarningCode.DOC_DIRECTIVE_MISSING_THREE_ARGUMENTS,
  WarningCode.DOC_DIRECTIVE_MISSING_TWO_ARGUMENTS,
  WarningCode.DOC_DIRECTIVE_UNKNOWN,
  WarningCode.DOC_IMPORT_CANNOT_BE_DEFERRED,
  WarningCode.DOC_IMPORT_CANNOT_HAVE_COMBINATORS,
  WarningCode.DOC_IMPORT_CANNOT_HAVE_CONFIGURATIONS,
  WarningCode.DOC_IMPORT_CANNOT_HAVE_PREFIX,
  WarningCode.DUPLICATE_EXPORT,
  WarningCode.DUPLICATE_HIDDEN_NAME,
  WarningCode.DUPLICATE_IGNORE,
  WarningCode.DUPLICATE_IMPORT,
  WarningCode.DUPLICATE_SHOWN_NAME,
  WarningCode.EQUAL_ELEMENTS_IN_SET,
  WarningCode.EQUAL_KEYS_IN_MAP,
  WarningCode.INFERENCE_FAILURE_ON_COLLECTION_LITERAL,
  WarningCode.INFERENCE_FAILURE_ON_FUNCTION_INVOCATION,
  WarningCode.INFERENCE_FAILURE_ON_FUNCTION_RETURN_TYPE,
  WarningCode.INFERENCE_FAILURE_ON_GENERIC_INVOCATION,
  WarningCode.INFERENCE_FAILURE_ON_INSTANCE_CREATION,
  WarningCode.INFERENCE_FAILURE_ON_UNINITIALIZED_VARIABLE,
  WarningCode.INFERENCE_FAILURE_ON_UNTYPED_PARAMETER,
  WarningCode.INVALID_ANNOTATION_TARGET,
  WarningCode.INVALID_EXPORT_OF_INTERNAL_ELEMENT,
  WarningCode.INVALID_EXPORT_OF_INTERNAL_ELEMENT_INDIRECTLY,
  WarningCode.INVALID_FACTORY_METHOD_DECL,
  WarningCode.INVALID_FACTORY_METHOD_IMPL,
  WarningCode.INVALID_INTERNAL_ANNOTATION,
  WarningCode.INVALID_LANGUAGE_VERSION_OVERRIDE_AT_SIGN,
  WarningCode.INVALID_LANGUAGE_VERSION_OVERRIDE_EQUALS,
  WarningCode.INVALID_LANGUAGE_VERSION_OVERRIDE_GREATER,
  WarningCode.INVALID_LANGUAGE_VERSION_OVERRIDE_LOCATION,
  WarningCode.INVALID_LANGUAGE_VERSION_OVERRIDE_LOWER_CASE,
  WarningCode.INVALID_LANGUAGE_VERSION_OVERRIDE_NUMBER,
  WarningCode.INVALID_LANGUAGE_VERSION_OVERRIDE_PREFIX,
  WarningCode.INVALID_LANGUAGE_VERSION_OVERRIDE_TRAILING_CHARACTERS,
  WarningCode.INVALID_LANGUAGE_VERSION_OVERRIDE_TWO_SLASHES,
  WarningCode.INVALID_LITERAL_ANNOTATION,
  WarningCode.INVALID_NON_VIRTUAL_ANNOTATION,
  WarningCode.INVALID_OVERRIDE_OF_NON_VIRTUAL_MEMBER,
  WarningCode.INVALID_REOPEN_ANNOTATION,
  WarningCode.INVALID_REQUIRED_NAMED_PARAM,
  WarningCode.INVALID_REQUIRED_OPTIONAL_POSITIONAL_PARAM,
  WarningCode.INVALID_REQUIRED_POSITIONAL_PARAM,
  WarningCode.INVALID_USE_OF_INTERNAL_MEMBER,
  WarningCode.INVALID_USE_OF_PROTECTED_MEMBER,
  WarningCode.INVALID_USE_OF_VISIBLE_FOR_OVERRIDING_MEMBER,
  WarningCode.INVALID_USE_OF_VISIBLE_FOR_TEMPLATE_MEMBER,
  WarningCode.INVALID_USE_OF_VISIBLE_FOR_TESTING_MEMBER,
  WarningCode.INVALID_VISIBILITY_ANNOTATION,
  WarningCode.INVALID_VISIBLE_FOR_OVERRIDING_ANNOTATION,
  WarningCode.INVALID_VISIBLE_OUTSIDE_TEMPLATE_ANNOTATION,
  WarningCode.MISSING_OVERRIDE_OF_MUST_BE_OVERRIDDEN_ONE,
  WarningCode.MISSING_OVERRIDE_OF_MUST_BE_OVERRIDDEN_THREE_PLUS,
  WarningCode.MISSING_OVERRIDE_OF_MUST_BE_OVERRIDDEN_TWO,
  WarningCode.MISSING_REQUIRED_PARAM,
  WarningCode.MISSING_REQUIRED_PARAM_WITH_DETAILS,
  WarningCode.MIXIN_ON_SEALED_CLASS,
  WarningCode.MULTIPLE_COMBINATORS,
  WarningCode.MUST_BE_IMMUTABLE,
  WarningCode.MUST_CALL_SUPER,
  WarningCode.NON_CONST_ARGUMENT_FOR_CONST_PARAMETER,
  WarningCode.NON_CONST_CALL_TO_LITERAL_CONSTRUCTOR,
  WarningCode.NON_CONST_CALL_TO_LITERAL_CONSTRUCTOR_USING_NEW,
  WarningCode.NON_NULLABLE_EQUALS_PARAMETER,
  WarningCode.NULLABLE_TYPE_IN_CATCH_CLAUSE,
  WarningCode.NULL_ARGUMENT_TO_NON_NULL_TYPE,
  WarningCode.NULL_CHECK_ALWAYS_FAILS,
  WarningCode.OVERRIDE_ON_NON_OVERRIDING_FIELD,
  WarningCode.OVERRIDE_ON_NON_OVERRIDING_GETTER,
  WarningCode.OVERRIDE_ON_NON_OVERRIDING_METHOD,
  WarningCode.OVERRIDE_ON_NON_OVERRIDING_SETTER,
  WarningCode.PATTERN_NEVER_MATCHES_VALUE_TYPE,
  WarningCode.RECEIVER_OF_TYPE_NEVER,
  WarningCode.REDECLARE_ON_NON_REDECLARING_MEMBER,
  WarningCode.REMOVED_LINT_USE,
  WarningCode.REPLACED_LINT_USE,
  WarningCode.RETURN_OF_DO_NOT_STORE,
  WarningCode.RETURN_OF_INVALID_TYPE_FROM_CATCH_ERROR,
  WarningCode.RETURN_TYPE_INVALID_FOR_CATCH_ERROR,
  WarningCode.SDK_VERSION_CONSTRUCTOR_TEAROFFS,
  WarningCode.SDK_VERSION_GT_GT_GT_OPERATOR,
  WarningCode.SDK_VERSION_SINCE,
  WarningCode.STRICT_RAW_TYPE,
  WarningCode.SUBTYPE_OF_SEALED_CLASS,
  WarningCode.TEXT_DIRECTION_CODE_POINT_IN_COMMENT,
  WarningCode.TEXT_DIRECTION_CODE_POINT_IN_LITERAL,
  WarningCode.TYPE_CHECK_IS_NOT_NULL,
  WarningCode.TYPE_CHECK_IS_NULL,
  WarningCode.UNDEFINED_HIDDEN_NAME,
  WarningCode.UNDEFINED_REFERENCED_PARAMETER,
  WarningCode.UNDEFINED_SHOWN_NAME,
  WarningCode.UNIGNORABLE_IGNORE,
  WarningCode.UNNECESSARY_CAST,
  WarningCode.UNNECESSARY_CAST_PATTERN,
  WarningCode.UNNECESSARY_FINAL,
  WarningCode.UNNECESSARY_NAN_COMPARISON_FALSE,
  WarningCode.UNNECESSARY_NAN_COMPARISON_TRUE,
  WarningCode.UNNECESSARY_NO_SUCH_METHOD,
  WarningCode.UNNECESSARY_NULL_COMPARISON_ALWAYS_NULL_FALSE,
  WarningCode.UNNECESSARY_NULL_COMPARISON_ALWAYS_NULL_TRUE,
  WarningCode.UNNECESSARY_NULL_COMPARISON_NEVER_NULL_FALSE,
  WarningCode.UNNECESSARY_NULL_COMPARISON_NEVER_NULL_TRUE,
  WarningCode.UNNECESSARY_QUESTION_MARK,
  WarningCode.UNNECESSARY_SET_LITERAL,
  WarningCode.UNNECESSARY_TYPE_CHECK_FALSE,
  WarningCode.UNNECESSARY_TYPE_CHECK_TRUE,
  WarningCode.UNNECESSARY_WILDCARD_PATTERN,
  WarningCode.UNREACHABLE_SWITCH_CASE,
  WarningCode.UNREACHABLE_SWITCH_DEFAULT,
  WarningCode.UNUSED_CATCH_CLAUSE,
  WarningCode.UNUSED_CATCH_STACK,
  WarningCode.UNUSED_ELEMENT,
  WarningCode.UNUSED_ELEMENT_PARAMETER,
  WarningCode.UNUSED_FIELD,
  WarningCode.UNUSED_IMPORT,
  WarningCode.UNUSED_LABEL,
  WarningCode.UNUSED_LOCAL_VARIABLE,
  WarningCode.UNUSED_RESULT,
  WarningCode.UNUSED_RESULT_WITH_MESSAGE,
  WarningCode.UNUSED_SHOWN_NAME,
  WarningCode.URI_DOES_NOT_EXIST_IN_DOC_IMPORT,
  WarningCode.invalid_use_of_do_not_submit_member,
];
