## 2.0.0

* **[Breaking]** `extensionFromMime(String mimeType)` returns `null` instead of `mimeType` for an unknown mime type.
* Update `extensionFromMime` to return a default extension when a MIME type maps to multiple extensions.

## 1.0.6

* Add `topics` section to `pubspec.yaml`.
* Move to `dart-lang/tools` monorepo.

## 1.0.5

* Update `video/mp4` mimeType lookup by header bytes.
* Add `image/heic` mimeType lookup by header bytes.
* Add `image/heif` mimeType lookup by header bytes.
* Add m4b mimeType lookup by extension.
* Add `text/markdown` mimeType lookup by extension.
* Require Dart 3.2.0.

## 1.0.4

* Changed `.js` to `text/javascript` per 
  https://datatracker.ietf.org/doc/html/rfc9239.
* Added `.mjs` as `text/javascript`.
* Add `application/dicom` mimeType lookup by extension.
* Require Dart 2.18.

## 1.0.3

* Add application/manifest+json lookup by extension.
* Add application/toml mimeType lookup by extension.
* Add audio/aac mimeType lookup by header bytes.
* Add audio/mpeg mimeType lookup by header bytes.
* Add audio/ogg mimeType lookup by header bytes.
* Add audio/weba mimeType lookup by header bytes.
* Add font/woff2 lookup by extension and header bytes.
* Add image/avif mimeType lookup by extension.
* Add image/heic mimeType lookup by extension.
* Add image/heif mimeType lookup by extension.
* Change audio/x-aac to audio/aac when detected by extension.

## 1.0.2

* Add audio/x-aiff mimeType lookup by header bytes.
* Add audio/x-flac mimeType lookup by header bytes.
* Add audio/x-wav mimeType lookup by header bytes.
* Add audio/mp4 mimeType lookup by file path.

## 1.0.1

* Add image/webp mimeType lookup by header bytes.

## 1.0.0

* Stable null safety release.

## 1.0.0-nullsafety.0

* Update to null safety.

## 0.9.7

* Add `extensionFromMime` utility function.

## 0.9.6+3

* Change the mime type for Dart source from `application/dart` to `text/x-dart`.
* Add example.
* Fix links and code in README.

## 0.9.6+2

* Set max SDK version to `<3.0.0`, and adjust other dependencies.

## 0.9.6+1

* Stop using deprecated constants from the SDK.

## 0.9.6

* Updates to support Dart 2.0 core library changes (wave
  2.2). See [issue 31847][sdk#31847] for details.

  [sdk#31847]: https://github.com/dart-lang/sdk/issues/31847

## 0.9.5

* Add support for the WebAssembly format.

## 0.9.4

* Updated Dart SDK requirement to `>= 1.8.3 <2.0.0`

* Strong-mode clean.

* Added support for glTF text and binary formats.

## 0.9.3

* Fixed erroneous behavior for listening and when pausing/resuming
  stream of parts.

## 0.9.2

* Fixed erroneous behavior when pausing/canceling stream of parts but already
  listened to one part.

## 0.9.1

* Handle parsing of MIME multipart content with no parts.
