// iuiautomationrangevaluepattern.dart

// THIS FILE IS GENERATED AUTOMATICALLY AND SHOULD NOT BE EDITED DIRECTLY.

// ignore_for_file: unused_import
// ignore_for_file: constant_identifier_names, non_constant_identifier_names
// ignore_for_file: no_leading_underscores_for_local_identifiers

import 'dart:ffi';

import 'package:ffi/ffi.dart';

import '../callbacks.dart';
import '../combase.dart';
import '../constants.dart';
import '../exceptions.dart';
import '../guid.dart';
import '../macros.dart';
import '../propertykey.dart';
import '../structs.g.dart';
import '../utils.dart';
import '../variant.dart';
import '../win32/ole32.g.dart';
import 'iunknown.dart';

/// @nodoc
const IID_IUIAutomationRangeValuePattern =
    '{59213f4f-7346-49e5-b120-80555987a148}';

/// Provides access to a control that presents a range of values.
///
/// {@category com}
class IUIAutomationRangeValuePattern extends IUnknown {
  // vtable begins at 3, is 13 entries long.
  IUIAutomationRangeValuePattern(super.ptr);

  factory IUIAutomationRangeValuePattern.from(IUnknown interface) =>
      IUIAutomationRangeValuePattern(
        interface.toInterface(IID_IUIAutomationRangeValuePattern),
      );

  int setValue(double val) => (ptr.ref.vtable + 3)
      .cast<Pointer<NativeFunction<Int32 Function(Pointer, Double val)>>>()
      .value
      .asFunction<int Function(Pointer, double val)>()(ptr.ref.lpVtbl, val);

  double get currentValue {
    final retValuePtr = calloc<Double>();

    try {
      final hr = (ptr.ref.vtable + 4)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Double> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Double> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  int get currentIsReadOnly {
    final retValuePtr = calloc<Int32>();

    try {
      final hr = (ptr.ref.vtable + 5)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Int32> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Int32> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  double get currentMaximum {
    final retValuePtr = calloc<Double>();

    try {
      final hr = (ptr.ref.vtable + 6)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Double> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Double> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  double get currentMinimum {
    final retValuePtr = calloc<Double>();

    try {
      final hr = (ptr.ref.vtable + 7)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Double> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Double> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  double get currentLargeChange {
    final retValuePtr = calloc<Double>();

    try {
      final hr = (ptr.ref.vtable + 8)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Double> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Double> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  double get currentSmallChange {
    final retValuePtr = calloc<Double>();

    try {
      final hr = (ptr.ref.vtable + 9)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Double> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Double> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  double get cachedValue {
    final retValuePtr = calloc<Double>();

    try {
      final hr = (ptr.ref.vtable + 10)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Double> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Double> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  int get cachedIsReadOnly {
    final retValuePtr = calloc<Int32>();

    try {
      final hr = (ptr.ref.vtable + 11)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Int32> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Int32> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  double get cachedMaximum {
    final retValuePtr = calloc<Double>();

    try {
      final hr = (ptr.ref.vtable + 12)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Double> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Double> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  double get cachedMinimum {
    final retValuePtr = calloc<Double>();

    try {
      final hr = (ptr.ref.vtable + 13)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Double> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Double> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  double get cachedLargeChange {
    final retValuePtr = calloc<Double>();

    try {
      final hr = (ptr.ref.vtable + 14)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Double> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Double> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  double get cachedSmallChange {
    final retValuePtr = calloc<Double>();

    try {
      final hr = (ptr.ref.vtable + 15)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Double> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Double> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }
}
