// iuiautomationscrollpattern.dart

// THIS FILE IS GENERATED AUTOMATICALLY AND SHOULD NOT BE EDITED DIRECTLY.

// ignore_for_file: unused_import
// ignore_for_file: constant_identifier_names, non_constant_identifier_names
// ignore_for_file: no_leading_underscores_for_local_identifiers

import 'dart:ffi';

import 'package:ffi/ffi.dart';

import '../callbacks.dart';
import '../combase.dart';
import '../constants.dart';
import '../exceptions.dart';
import '../guid.dart';
import '../macros.dart';
import '../propertykey.dart';
import '../structs.g.dart';
import '../utils.dart';
import '../variant.dart';
import '../win32/ole32.g.dart';
import 'iunknown.dart';

/// @nodoc
const IID_IUIAutomationScrollPattern = '{88f4d42a-e881-459d-a77c-73bbbb7e02dc}';

/// Provides access to a control that acts as a scrollable container for a
/// collection of child elements.
///
/// {@category com}
class IUIAutomationScrollPattern extends IUnknown {
  // vtable begins at 3, is 14 entries long.
  IUIAutomationScrollPattern(super.ptr);

  factory IUIAutomationScrollPattern.from(IUnknown interface) =>
      IUIAutomationScrollPattern(
        interface.toInterface(IID_IUIAutomationScrollPattern),
      );

  int scroll(int horizontalAmount, int verticalAmount) => (ptr.ref.vtable + 3)
      .cast<
        Pointer<
          NativeFunction<
            Int32 Function(
              Pointer,
              Int32 horizontalAmount,
              Int32 verticalAmount,
            )
          >
        >
      >()
      .value
      .asFunction<
        int Function(Pointer, int horizontalAmount, int verticalAmount)
      >()(ptr.ref.lpVtbl, horizontalAmount, verticalAmount);

  int setScrollPercent(double horizontalPercent, double verticalPercent) =>
      (ptr.ref.vtable + 4)
          .cast<
            Pointer<
              NativeFunction<
                Int32 Function(
                  Pointer,
                  Double horizontalPercent,
                  Double verticalPercent,
                )
              >
            >
          >()
          .value
          .asFunction<
            int Function(
              Pointer,
              double horizontalPercent,
              double verticalPercent,
            )
          >()(ptr.ref.lpVtbl, horizontalPercent, verticalPercent);

  double get currentHorizontalScrollPercent {
    final retValuePtr = calloc<Double>();

    try {
      final hr = (ptr.ref.vtable + 5)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Double> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Double> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  double get currentVerticalScrollPercent {
    final retValuePtr = calloc<Double>();

    try {
      final hr = (ptr.ref.vtable + 6)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Double> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Double> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  double get currentHorizontalViewSize {
    final retValuePtr = calloc<Double>();

    try {
      final hr = (ptr.ref.vtable + 7)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Double> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Double> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  double get currentVerticalViewSize {
    final retValuePtr = calloc<Double>();

    try {
      final hr = (ptr.ref.vtable + 8)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Double> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Double> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  int get currentHorizontallyScrollable {
    final retValuePtr = calloc<Int32>();

    try {
      final hr = (ptr.ref.vtable + 9)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Int32> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Int32> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  int get currentVerticallyScrollable {
    final retValuePtr = calloc<Int32>();

    try {
      final hr = (ptr.ref.vtable + 10)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Int32> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Int32> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  double get cachedHorizontalScrollPercent {
    final retValuePtr = calloc<Double>();

    try {
      final hr = (ptr.ref.vtable + 11)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Double> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Double> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  double get cachedVerticalScrollPercent {
    final retValuePtr = calloc<Double>();

    try {
      final hr = (ptr.ref.vtable + 12)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Double> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Double> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  double get cachedHorizontalViewSize {
    final retValuePtr = calloc<Double>();

    try {
      final hr = (ptr.ref.vtable + 13)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Double> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Double> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  double get cachedVerticalViewSize {
    final retValuePtr = calloc<Double>();

    try {
      final hr = (ptr.ref.vtable + 14)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Double> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Double> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  int get cachedHorizontallyScrollable {
    final retValuePtr = calloc<Int32>();

    try {
      final hr = (ptr.ref.vtable + 15)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Int32> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Int32> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  int get cachedVerticallyScrollable {
    final retValuePtr = calloc<Int32>();

    try {
      final hr = (ptr.ref.vtable + 16)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Int32> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Int32> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }
}
