// iuiautomationtransformpattern.dart

// THIS FILE IS GENERATED AUTOMATICALLY AND SHOULD NOT BE EDITED DIRECTLY.

// ignore_for_file: unused_import
// ignore_for_file: constant_identifier_names, non_constant_identifier_names
// ignore_for_file: no_leading_underscores_for_local_identifiers

import 'dart:ffi';

import 'package:ffi/ffi.dart';

import '../callbacks.dart';
import '../combase.dart';
import '../constants.dart';
import '../exceptions.dart';
import '../guid.dart';
import '../macros.dart';
import '../propertykey.dart';
import '../structs.g.dart';
import '../utils.dart';
import '../variant.dart';
import '../win32/ole32.g.dart';
import 'iunknown.dart';

/// @nodoc
const IID_IUIAutomationTransformPattern =
    '{a9b55844-a55d-4ef0-926d-569c16ff89bb}';

/// Provides access to a control that can be moved, resized, or rotated.
///
/// {@category com}
class IUIAutomationTransformPattern extends IUnknown {
  // vtable begins at 3, is 9 entries long.
  IUIAutomationTransformPattern(super.ptr);

  factory IUIAutomationTransformPattern.from(IUnknown interface) =>
      IUIAutomationTransformPattern(
        interface.toInterface(IID_IUIAutomationTransformPattern),
      );

  int move(double x, double y) => (ptr.ref.vtable + 3)
      .cast<
        Pointer<NativeFunction<Int32 Function(Pointer, Double x, Double y)>>
      >()
      .value
      .asFunction<int Function(Pointer, double x, double y)>()(
    ptr.ref.lpVtbl,
    x,
    y,
  );

  int resize(double width, double height) => (ptr.ref.vtable + 4)
      .cast<
        Pointer<
          NativeFunction<Int32 Function(Pointer, Double width, Double height)>
        >
      >()
      .value
      .asFunction<int Function(Pointer, double width, double height)>()(
    ptr.ref.lpVtbl,
    width,
    height,
  );

  int rotate(double degrees) => (ptr.ref.vtable + 5)
      .cast<Pointer<NativeFunction<Int32 Function(Pointer, Double degrees)>>>()
      .value
      .asFunction<int Function(Pointer, double degrees)>()(
    ptr.ref.lpVtbl,
    degrees,
  );

  int get currentCanMove {
    final retValuePtr = calloc<Int32>();

    try {
      final hr = (ptr.ref.vtable + 6)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Int32> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Int32> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  int get currentCanResize {
    final retValuePtr = calloc<Int32>();

    try {
      final hr = (ptr.ref.vtable + 7)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Int32> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Int32> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  int get currentCanRotate {
    final retValuePtr = calloc<Int32>();

    try {
      final hr = (ptr.ref.vtable + 8)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Int32> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Int32> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  int get cachedCanMove {
    final retValuePtr = calloc<Int32>();

    try {
      final hr = (ptr.ref.vtable + 9)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Int32> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Int32> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  int get cachedCanResize {
    final retValuePtr = calloc<Int32>();

    try {
      final hr = (ptr.ref.vtable + 10)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Int32> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Int32> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }

  int get cachedCanRotate {
    final retValuePtr = calloc<Int32>();

    try {
      final hr = (ptr.ref.vtable + 11)
          .cast<
            Pointer<
              NativeFunction<Int32 Function(Pointer, Pointer<Int32> retVal)>
            >
          >()
          .value
          .asFunction<int Function(Pointer, Pointer<Int32> retVal)>()(
        ptr.ref.lpVtbl,
        retValuePtr,
      );

      if (FAILED(hr)) throw WindowsException(hr);

      final retValue = retValuePtr.value;
      return retValue;
    } finally {
      free(retValuePtr);
    }
  }
}
